

// This C++ file was created by SanEditor

#include "Atomic/Middleware_SAN/Middleware_SANSAN.h"

#include <stdlib.h>
#include <iostream>

#include <math.h>


/*****************************************************************
                         Middleware_SANSAN Constructor             
******************************************************************/


Middleware_SANSAN::Middleware_SANSAN(){


  Activity* InitialActionList[10]={
    &IA_Buffer_1, //0
    &IA_Buffer_1_utilisation, //1
    &IA_Buffer_2_utilisation, //2
    &IA_Signal_Server, //3
    &IA_Results_SingleServer, //4
    &IA_Exception, //5
    &TA_Mutex_pool, //6
    &TA_Results, //7
    &TA_Oper_Edge_detection, //8
    &TA_Mutex_release  // 9
  };

  BaseGroupClass* InitialGroupList[10]={
    (BaseGroupClass*) &(TA_Results), 
    (BaseGroupClass*) &(TA_Oper_Edge_detection), 
    (BaseGroupClass*) &(TA_Mutex_release), 
    (BaseGroupClass*) &(IA_Buffer_1), 
    (BaseGroupClass*) &(IA_Buffer_1_utilisation), 
    (BaseGroupClass*) &(IA_Buffer_2_utilisation), 
    (BaseGroupClass*) &(IA_Signal_Server), 
    (BaseGroupClass*) &(IA_Results_SingleServer), 
    (BaseGroupClass*) &(IA_Exception), 
    (BaseGroupClass*) &(TA_Mutex_pool)
  };

  Execute_Transaction_current = new Place("Execute_Transaction_current" ,0);
  Request_Operation_Server_current = new Place("Request_Operation_Server_current" ,0);
  Request_Operation_Server_1 = new Place("Request_Operation_Server_1" ,0);
  Execute_Transaction_1 = new Place("Execute_Transaction_1" ,0);
  Request_Operation_Server_2 = new Place("Request_Operation_Server_2" ,0);
  Execute_Transaction_2 = new Place("Execute_Transaction_2" ,0);
  Mutex_pool = new Place("Mutex_pool" ,0);
  Server_1_enabled = new Place("Server_1_enabled" ,GV_Server_1_enabled);
  Server_2_enabled = new Place("Server_2_enabled" ,GV_Server_2_enabled);
  Mutex_granted = new Place("Mutex_granted" ,0);
  Mutex_requested = new Place("Mutex_requested" ,0);
  Middleware_ID = new Place("Middleware_ID" ,0);
  Operation_Executed_Server_1 = new Place("Operation_Executed_Server_1" ,0);
  Operation_Executed_Server_2 = new Place("Operation_Executed_Server_2" ,0);
  Buffer_Operations = new Place("Buffer_Operations" ,0);
  Signal_Server = new Place("Signal_Server" ,0);
  Oper_Edge_detection_called = new Place("Oper_Edge_detection_called" ,0);
  Buffer_1_progress = new Place("Buffer_1_progress" ,0);
  Buffer_2_progress = new Place("Buffer_2_progress" ,0);
  Buffer_1_called = new Place("Buffer_1_called" ,0);
  Buffer_2_called = new Place("Buffer_2_called" ,0);
  Operation_Executed_current = new Place("Operation_Executed_current" ,0);
  Exception = new Place("Exception" ,0);
  Begin_called_1 = new Place("Begin_called_1" ,0);
  Begin_called_2 = new Place("Begin_called_2" ,0);
  Wait_for_slower_server = new Place("Wait_for_slower_server" ,0);
  BaseStateVariableClass* InitialPlaces[26]={
    Execute_Transaction_current,  // 0
    Request_Operation_Server_current,  // 1
    Request_Operation_Server_1,  // 2
    Execute_Transaction_1,  // 3
    Request_Operation_Server_2,  // 4
    Execute_Transaction_2,  // 5
    Mutex_pool,  // 6
    Server_1_enabled,  // 7
    Server_2_enabled,  // 8
    Mutex_granted,  // 9
    Mutex_requested,  // 10
    Middleware_ID,  // 11
    Operation_Executed_Server_1,  // 12
    Operation_Executed_Server_2,  // 13
    Buffer_Operations,  // 14
    Signal_Server,  // 15
    Oper_Edge_detection_called,  // 16
    Buffer_1_progress,  // 17
    Buffer_2_progress,  // 18
    Buffer_1_called,  // 19
    Buffer_2_called,  // 20
    Operation_Executed_current,  // 21
    Exception,  // 22
    Begin_called_1,  // 23
    Begin_called_2,  // 24
    Wait_for_slower_server   // 25
  };
  BaseStateVariableClass* InitialROPlaces[0]={
  };
  initializeSANModelNow("Middleware_SAN", 26, InitialPlaces, 
                        0, InitialROPlaces, 
                        10, InitialActionList, 10, InitialGroupList);


  assignPlacesToActivitiesInst();
  assignPlacesToActivitiesTimed();

  int AffectArcs[103][2]={ 
    {19,0}, {20,0}, {14,0}, {17,0}, {18,0}, {11,0}, {11,1}, {17,1}, 
    {19,1}, {3,1}, {2,1}, {0,1}, {1,1}, {11,2}, {18,2}, {20,2}, 
    {5,2}, {4,2}, {0,2}, {1,2}, {15,3}, {7,3}, {2,3}, {1,3}, 
    {3,3}, {0,3}, {8,3}, {4,3}, {5,3}, {11,3}, {11,4}, {7,4}, 
    {21,4}, {12,4}, {0,4}, {3,4}, {1,4}, {2,4}, {16,4}, {8,4}, 
    {13,4}, {5,4}, {4,4}, {11,5}, {0,5}, {17,5}, {18,5}, {1,5}, 
    {12,5}, {13,5}, {21,5}, {22,5}, {16,5}, {3,5}, {2,5}, {6,6}, 
    {10,6}, {9,6}, {11,6}, {2,6}, {1,6}, {3,6}, {0,6}, {4,6}, 
    {5,6}, {11,7}, {0,7}, {12,7}, {13,7}, {22,7}, {21,7}, {1,7}, 
    {2,7}, {3,7}, {16,7}, {4,7}, {5,7}, {14,7}, {19,7}, {17,7}, 
    {7,7}, {8,7}, {20,7}, {18,7}, {25,7}, {16,8}, {11,8}, {0,8}, 
    {7,8}, {8,8}, {6,8}, {10,8}, {9,8}, {22,8}, {14,8}, {15,8}, 
    {9,9}, {11,9}, {6,9}, {10,9}, {7,9}, {8,9}, {22,9}
  };
  for(int n=0;n<103;n++) {
    AddAffectArc(InitialPlaces[AffectArcs[n][0]],
                 InitialActionList[AffectArcs[n][1]]);
  }
  int EnableArcs[52][2]={ 
    {14,0}, {7,0}, {8,0}, {22,0}, {17,1}, {19,1}, {7,1}, {8,1}, 
    {18,2}, {20,2}, {7,2}, {8,2}, {15,3}, {7,4}, {8,4}, {12,4}, 
    {13,4}, {22,5}, {12,5}, {13,5}, {1,5}, {0,5}, {16,5}, {6,6}, 
    {10,6}, {9,6}, {7,6}, {8,6}, {22,6}, {11,6}, {9,7}, {11,7}, 
    {12,7}, {13,7}, {7,7}, {8,7}, {22,7}, {7,8}, {23,8}, {1,8}, 
    {0,8}, {8,8}, {24,8}, {16,8}, {22,8}, {21,8}, {9,9}, {11,9}, 
    {12,9}, {13,9}, {7,9}, {8,9}
  };
  for(int n=0;n<52;n++) {
    AddEnableArc(InitialPlaces[EnableArcs[n][0]],
                 InitialActionList[EnableArcs[n][1]]);
  }

  for(int n=0;n<10;n++) {
    InitialActionList[n]->LinkVariables();
  }
  CustomInitialization();

}

void Middleware_SANSAN::CustomInitialization() {

}
Middleware_SANSAN::~Middleware_SANSAN(){
  for (int i = 0; i < NumStateVariables-NumReadOnlyPlaces; i++)
    delete LocalStateVariables[i];
};

void Middleware_SANSAN::assignPlacesToActivitiesInst(){
  IA_Buffer_1.Buffer_Operations = (Place*) LocalStateVariables[14];
  IA_Buffer_1.Server_1_enabled = (Place*) LocalStateVariables[7];
  IA_Buffer_1.Server_2_enabled = (Place*) LocalStateVariables[8];
  IA_Buffer_1.Exception = (Place*) LocalStateVariables[22];
  IA_Buffer_1.Buffer_1_called = (Place*) LocalStateVariables[19];
  IA_Buffer_1.Buffer_2_called = (Place*) LocalStateVariables[20];
  IA_Buffer_1.Buffer_1_progress = (Place*) LocalStateVariables[17];
  IA_Buffer_1.Buffer_2_progress = (Place*) LocalStateVariables[18];
  IA_Buffer_1.Middleware_ID = (Place*) LocalStateVariables[11];
  IA_Buffer_1_utilisation.Buffer_1_progress = (Place*) LocalStateVariables[17];
  IA_Buffer_1_utilisation.Buffer_1_called = (Place*) LocalStateVariables[19];
  IA_Buffer_1_utilisation.Server_1_enabled = (Place*) LocalStateVariables[7];
  IA_Buffer_1_utilisation.Server_2_enabled = (Place*) LocalStateVariables[8];
  IA_Buffer_1_utilisation.Middleware_ID = (Place*) LocalStateVariables[11];
  IA_Buffer_1_utilisation.Execute_Transaction_1 = (Place*) LocalStateVariables[3];
  IA_Buffer_1_utilisation.Request_Operation_Server_1 = (Place*) LocalStateVariables[2];
  IA_Buffer_1_utilisation.Execute_Transaction_current = (Place*) LocalStateVariables[0];
  IA_Buffer_1_utilisation.Request_Operation_Server_current = (Place*) LocalStateVariables[1];
  IA_Buffer_2_utilisation.Buffer_2_progress = (Place*) LocalStateVariables[18];
  IA_Buffer_2_utilisation.Buffer_2_called = (Place*) LocalStateVariables[20];
  IA_Buffer_2_utilisation.Server_1_enabled = (Place*) LocalStateVariables[7];
  IA_Buffer_2_utilisation.Server_2_enabled = (Place*) LocalStateVariables[8];
  IA_Buffer_2_utilisation.Middleware_ID = (Place*) LocalStateVariables[11];
  IA_Buffer_2_utilisation.Execute_Transaction_2 = (Place*) LocalStateVariables[5];
  IA_Buffer_2_utilisation.Request_Operation_Server_2 = (Place*) LocalStateVariables[4];
  IA_Buffer_2_utilisation.Execute_Transaction_current = (Place*) LocalStateVariables[0];
  IA_Buffer_2_utilisation.Request_Operation_Server_current = (Place*) LocalStateVariables[1];
  IA_Signal_Server.Signal_Server = (Place*) LocalStateVariables[15];
  IA_Signal_Server.Server_1_enabled = (Place*) LocalStateVariables[7];
  IA_Signal_Server.Request_Operation_Server_1 = (Place*) LocalStateVariables[2];
  IA_Signal_Server.Request_Operation_Server_current = (Place*) LocalStateVariables[1];
  IA_Signal_Server.Execute_Transaction_1 = (Place*) LocalStateVariables[3];
  IA_Signal_Server.Execute_Transaction_current = (Place*) LocalStateVariables[0];
  IA_Signal_Server.Server_2_enabled = (Place*) LocalStateVariables[8];
  IA_Signal_Server.Request_Operation_Server_2 = (Place*) LocalStateVariables[4];
  IA_Signal_Server.Execute_Transaction_2 = (Place*) LocalStateVariables[5];
  IA_Signal_Server.Middleware_ID = (Place*) LocalStateVariables[11];
  IA_Results_SingleServer.Server_1_enabled = (Place*) LocalStateVariables[7];
  IA_Results_SingleServer.Server_2_enabled = (Place*) LocalStateVariables[8];
  IA_Results_SingleServer.Operation_Executed_Server_1 = (Place*) LocalStateVariables[12];
  IA_Results_SingleServer.Operation_Executed_Server_2 = (Place*) LocalStateVariables[13];
  IA_Results_SingleServer.Middleware_ID = (Place*) LocalStateVariables[11];
  IA_Results_SingleServer.Operation_Executed_current = (Place*) LocalStateVariables[21];
  IA_Results_SingleServer.Execute_Transaction_current = (Place*) LocalStateVariables[0];
  IA_Results_SingleServer.Execute_Transaction_1 = (Place*) LocalStateVariables[3];
  IA_Results_SingleServer.Request_Operation_Server_current = (Place*) LocalStateVariables[1];
  IA_Results_SingleServer.Request_Operation_Server_1 = (Place*) LocalStateVariables[2];
  IA_Results_SingleServer.Oper_Edge_detection_called = (Place*) LocalStateVariables[16];
  IA_Results_SingleServer.Execute_Transaction_2 = (Place*) LocalStateVariables[5];
  IA_Results_SingleServer.Request_Operation_Server_2 = (Place*) LocalStateVariables[4];
  IA_Exception.Exception = (Place*) LocalStateVariables[22];
  IA_Exception.Operation_Executed_Server_1 = (Place*) LocalStateVariables[12];
  IA_Exception.Operation_Executed_Server_2 = (Place*) LocalStateVariables[13];
  IA_Exception.Request_Operation_Server_current = (Place*) LocalStateVariables[1];
  IA_Exception.Execute_Transaction_current = (Place*) LocalStateVariables[0];
  IA_Exception.Oper_Edge_detection_called = (Place*) LocalStateVariables[16];
  IA_Exception.Middleware_ID = (Place*) LocalStateVariables[11];
  IA_Exception.Buffer_1_progress = (Place*) LocalStateVariables[17];
  IA_Exception.Buffer_2_progress = (Place*) LocalStateVariables[18];
  IA_Exception.Operation_Executed_current = (Place*) LocalStateVariables[21];
  IA_Exception.Execute_Transaction_1 = (Place*) LocalStateVariables[3];
  IA_Exception.Request_Operation_Server_1 = (Place*) LocalStateVariables[2];
  TA_Mutex_pool.Mutex_pool = (Place*) LocalStateVariables[6];
  TA_Mutex_pool.Mutex_requested = (Place*) LocalStateVariables[10];
  TA_Mutex_pool.Mutex_granted = (Place*) LocalStateVariables[9];
  TA_Mutex_pool.Server_1_enabled = (Place*) LocalStateVariables[7];
  TA_Mutex_pool.Server_2_enabled = (Place*) LocalStateVariables[8];
  TA_Mutex_pool.Exception = (Place*) LocalStateVariables[22];
  TA_Mutex_pool.Middleware_ID = (Place*) LocalStateVariables[11];
  TA_Mutex_pool.Request_Operation_Server_1 = (Place*) LocalStateVariables[2];
  TA_Mutex_pool.Request_Operation_Server_current = (Place*) LocalStateVariables[1];
  TA_Mutex_pool.Execute_Transaction_1 = (Place*) LocalStateVariables[3];
  TA_Mutex_pool.Execute_Transaction_current = (Place*) LocalStateVariables[0];
  TA_Mutex_pool.Request_Operation_Server_2 = (Place*) LocalStateVariables[4];
  TA_Mutex_pool.Execute_Transaction_2 = (Place*) LocalStateVariables[5];
}
void Middleware_SANSAN::assignPlacesToActivitiesTimed(){
  TA_Results.Mutex_granted = (Place*) LocalStateVariables[9];
  TA_Results.Middleware_ID = (Place*) LocalStateVariables[11];
  TA_Results.Operation_Executed_Server_1 = (Place*) LocalStateVariables[12];
  TA_Results.Operation_Executed_Server_2 = (Place*) LocalStateVariables[13];
  TA_Results.Server_1_enabled = (Place*) LocalStateVariables[7];
  TA_Results.Server_2_enabled = (Place*) LocalStateVariables[8];
  TA_Results.Exception = (Place*) LocalStateVariables[22];
  TA_Results.Execute_Transaction_current = (Place*) LocalStateVariables[0];
  TA_Results.Operation_Executed_current = (Place*) LocalStateVariables[21];
  TA_Results.Request_Operation_Server_current = (Place*) LocalStateVariables[1];
  TA_Results.Request_Operation_Server_1 = (Place*) LocalStateVariables[2];
  TA_Results.Execute_Transaction_1 = (Place*) LocalStateVariables[3];
  TA_Results.Oper_Edge_detection_called = (Place*) LocalStateVariables[16];
  TA_Results.Request_Operation_Server_2 = (Place*) LocalStateVariables[4];
  TA_Results.Execute_Transaction_2 = (Place*) LocalStateVariables[5];
  TA_Results.Buffer_Operations = (Place*) LocalStateVariables[14];
  TA_Results.Buffer_1_called = (Place*) LocalStateVariables[19];
  TA_Results.Buffer_1_progress = (Place*) LocalStateVariables[17];
  TA_Results.Buffer_2_called = (Place*) LocalStateVariables[20];
  TA_Results.Buffer_2_progress = (Place*) LocalStateVariables[18];
  TA_Results.Wait_for_slower_server = (Place*) LocalStateVariables[25];
  TA_Oper_Edge_detection.Server_1_enabled = (Place*) LocalStateVariables[7];
  TA_Oper_Edge_detection.Begin_called_1 = (Place*) LocalStateVariables[23];
  TA_Oper_Edge_detection.Request_Operation_Server_current = (Place*) LocalStateVariables[1];
  TA_Oper_Edge_detection.Execute_Transaction_current = (Place*) LocalStateVariables[0];
  TA_Oper_Edge_detection.Server_2_enabled = (Place*) LocalStateVariables[8];
  TA_Oper_Edge_detection.Begin_called_2 = (Place*) LocalStateVariables[24];
  TA_Oper_Edge_detection.Oper_Edge_detection_called = (Place*) LocalStateVariables[16];
  TA_Oper_Edge_detection.Exception = (Place*) LocalStateVariables[22];
  TA_Oper_Edge_detection.Operation_Executed_current = (Place*) LocalStateVariables[21];
  TA_Oper_Edge_detection.Middleware_ID = (Place*) LocalStateVariables[11];
  TA_Oper_Edge_detection.Mutex_pool = (Place*) LocalStateVariables[6];
  TA_Oper_Edge_detection.Mutex_requested = (Place*) LocalStateVariables[10];
  TA_Oper_Edge_detection.Mutex_granted = (Place*) LocalStateVariables[9];
  TA_Oper_Edge_detection.Buffer_Operations = (Place*) LocalStateVariables[14];
  TA_Oper_Edge_detection.Signal_Server = (Place*) LocalStateVariables[15];
  TA_Mutex_release.Mutex_granted = (Place*) LocalStateVariables[9];
  TA_Mutex_release.Middleware_ID = (Place*) LocalStateVariables[11];
  TA_Mutex_release.Operation_Executed_Server_1 = (Place*) LocalStateVariables[12];
  TA_Mutex_release.Operation_Executed_Server_2 = (Place*) LocalStateVariables[13];
  TA_Mutex_release.Server_1_enabled = (Place*) LocalStateVariables[7];
  TA_Mutex_release.Server_2_enabled = (Place*) LocalStateVariables[8];
  TA_Mutex_release.Mutex_pool = (Place*) LocalStateVariables[6];
  TA_Mutex_release.Mutex_requested = (Place*) LocalStateVariables[10];
  TA_Mutex_release.Exception = (Place*) LocalStateVariables[22];
}
/*****************************************************************/
/*                  Activity Method Definitions                  */
/*****************************************************************/

/*======================IA_Buffer_1Activity========================*/


Middleware_SANSAN::IA_Buffer_1Activity::IA_Buffer_1Activity(){
  ActivityInitialize("IA_Buffer_1",3,Instantaneous , RaceEnabled, 6,4, false);
}

void Middleware_SANSAN::IA_Buffer_1Activity::LinkVariables(){
  Buffer_Operations->Register(&Buffer_Operations_Mobius_Mark);
  Server_1_enabled->Register(&Server_1_enabled_Mobius_Mark);
  Server_2_enabled->Register(&Server_2_enabled_Mobius_Mark);
  Exception->Register(&Exception_Mobius_Mark);
  Buffer_1_called->Register(&Buffer_1_called_Mobius_Mark);
  Buffer_2_called->Register(&Buffer_2_called_Mobius_Mark);
  Buffer_1_progress->Register(&Buffer_1_progress_Mobius_Mark);
  Buffer_2_progress->Register(&Buffer_2_progress_Mobius_Mark);
  Middleware_ID->Register(&Middleware_ID_Mobius_Mark);
}

bool Middleware_SANSAN::IA_Buffer_1Activity::Enabled(){
  OldEnabled=NewEnabled;
  NewEnabled=(((Buffer_Operations->Mark()==1)&&(Server_1_enabled->Mark()==1)&&(Server_2_enabled->Mark()==1)&&(Exception->Mark()==0)));
  return NewEnabled;
}

double Middleware_SANSAN::IA_Buffer_1Activity::Weight(){ 
  return 1;
}

bool Middleware_SANSAN::IA_Buffer_1Activity::ReactivationPredicate(){ 
  return false;
}

bool Middleware_SANSAN::IA_Buffer_1Activity::ReactivationFunction(){ 
  return false;
}

double Middleware_SANSAN::IA_Buffer_1Activity::SampleDistribution(){
  return 0;
}

double* Middleware_SANSAN::IA_Buffer_1Activity::ReturnDistributionParameters(){
    return NULL;
}

int Middleware_SANSAN::IA_Buffer_1Activity::Rank(){
  return 1;
}

BaseActionClass* Middleware_SANSAN::IA_Buffer_1Activity::Fire(){
  if(GV_debug_flag==25)
{
   std::cerr << "IG_Buffer : The value of Buffer_1_called->Mark() is " << Buffer_1_called->Mark() << endl;
   std::cerr << "IG_Buffer : The value of Buffer_2_called->Mark() is " << Buffer_2_called->Mark() << endl;
}

/* Stop the buffering from occurring more than once */
Buffer_Operations->Mark()=0;

/* Buffer the operations for each server and signal that the buffering has taken place */
Buffer_1_progress->Mark() = Buffer_1_progress->Mark() + 1;
Buffer_2_progress->Mark() = Buffer_2_progress->Mark() + 1;


/* else, if NOT an egde && (Server_1_enabled && Server_2_enabled) then signal the faster, or both, servers  */
switch(MW_ptr->MW_signal_server(Middleware_ID->Mark()) + 1)
{
        case 1: 
            Buffer_1_called->Mark() = 0;
            break;
        case 2:
            Buffer_2_called->Mark() = 0;
            break;
        case 3:
            Buffer_1_called->Mark() = 0;
            Buffer_2_called->Mark() = 0; 
            break;
}
  return this;
}

/*======================IA_Buffer_1_utilisationActivity========================*/


Middleware_SANSAN::IA_Buffer_1_utilisationActivity::IA_Buffer_1_utilisationActivity(){
  ActivityInitialize("IA_Buffer_1_utilisation",4,Instantaneous , RaceEnabled, 7,4, false);
}

void Middleware_SANSAN::IA_Buffer_1_utilisationActivity::LinkVariables(){
  Buffer_1_progress->Register(&Buffer_1_progress_Mobius_Mark);
  Buffer_1_called->Register(&Buffer_1_called_Mobius_Mark);
  Server_1_enabled->Register(&Server_1_enabled_Mobius_Mark);
  Server_2_enabled->Register(&Server_2_enabled_Mobius_Mark);
  Middleware_ID->Register(&Middleware_ID_Mobius_Mark);
  Execute_Transaction_1->Register(&Execute_Transaction_1_Mobius_Mark);
  Request_Operation_Server_1->Register(&Request_Operation_Server_1_Mobius_Mark);
  Execute_Transaction_current->Register(&Execute_Transaction_current_Mobius_Mark);
  Request_Operation_Server_current->Register(&Request_Operation_Server_current_Mobius_Mark);
}

bool Middleware_SANSAN::IA_Buffer_1_utilisationActivity::Enabled(){
  OldEnabled=NewEnabled;
  NewEnabled=(((Buffer_1_progress->Mark()>0)&&(Buffer_1_called->Mark()==0)&&(Server_1_enabled->Mark()==1)&&(Server_2_enabled->Mark()==1)));
  return NewEnabled;
}

double Middleware_SANSAN::IA_Buffer_1_utilisationActivity::Weight(){ 
  return 1;
}

bool Middleware_SANSAN::IA_Buffer_1_utilisationActivity::ReactivationPredicate(){ 
  return false;
}

bool Middleware_SANSAN::IA_Buffer_1_utilisationActivity::ReactivationFunction(){ 
  return false;
}

double Middleware_SANSAN::IA_Buffer_1_utilisationActivity::SampleDistribution(){
  return 0;
}

double* Middleware_SANSAN::IA_Buffer_1_utilisationActivity::ReturnDistributionParameters(){
    return NULL;
}

int Middleware_SANSAN::IA_Buffer_1_utilisationActivity::Rank(){
  return 1;
}

BaseActionClass* Middleware_SANSAN::IA_Buffer_1_utilisationActivity::Fire(){
  if(GV_debug_flag==25)
{
        std::cerr << "\n\nMiddleware::IG_Buffer_1 : The value of MW_ptr->Server_get_operation(Trans_ID,Server_ID) is " << MW_ptr->Server_get_operation(Middleware_ID->Mark(),1) << std::endl;     
        std::cerr << "\n\nMiddleware::IG_Buffer_1 : The value of Buffer_1_progress->Mark() is " << Buffer_1_progress->Mark() << std::endl;     
        std::cerr << "\n\nMiddleware::IG_Buffer_1 : The value of MW_ptr->MW_get_Trans_progress(Middleware_ID->Mark(), 1) is " << MW_ptr->MW_get_Trans_progress(Middleware_ID->Mark(), 1) << std::endl;
}

/* Signal to Server 1 what the next operation should be */
Buffer_1_progress->Mark() = Buffer_1_progress->Mark() - 1;
Buffer_1_called->Mark() = 1;

/* Set the appropriate signal for the server to perform the client request */
//if((MW_ptr->Server_get_operation(Middleware_ID->Mark(),1)).compare(std::string("Begin"))==0)
//{
//    /* A begin edge is detected, so only the "Execute_Transaction" should be activated */
//    Execute_Transaction_1->Mark() = 1;
//    Request_Operation_Server_1->Mark() = 0;

//}else
{
    /* All other operations and edges require both flags to be activated */
    Execute_Transaction_1->Mark() = 1;
    Request_Operation_Server_1->Mark() = 1;    
}

/* Reset signals from client, if this is being sent to the faster server */
if(MW_ptr->MW_signal_server(Middleware_ID->Mark())==0)
{
    /* Yes, Server 1 is the faster server */
    Execute_Transaction_current->Mark() = 0;
    Request_Operation_Server_current->Mark() = 0;
}
  return this;
}

/*======================IA_Buffer_2_utilisationActivity========================*/


Middleware_SANSAN::IA_Buffer_2_utilisationActivity::IA_Buffer_2_utilisationActivity(){
  ActivityInitialize("IA_Buffer_2_utilisation",5,Instantaneous , RaceEnabled, 7,4, false);
}

void Middleware_SANSAN::IA_Buffer_2_utilisationActivity::LinkVariables(){
  Buffer_2_progress->Register(&Buffer_2_progress_Mobius_Mark);
  Buffer_2_called->Register(&Buffer_2_called_Mobius_Mark);
  Server_1_enabled->Register(&Server_1_enabled_Mobius_Mark);
  Server_2_enabled->Register(&Server_2_enabled_Mobius_Mark);
  Middleware_ID->Register(&Middleware_ID_Mobius_Mark);
  Execute_Transaction_2->Register(&Execute_Transaction_2_Mobius_Mark);
  Request_Operation_Server_2->Register(&Request_Operation_Server_2_Mobius_Mark);
  Execute_Transaction_current->Register(&Execute_Transaction_current_Mobius_Mark);
  Request_Operation_Server_current->Register(&Request_Operation_Server_current_Mobius_Mark);
}

bool Middleware_SANSAN::IA_Buffer_2_utilisationActivity::Enabled(){
  OldEnabled=NewEnabled;
  NewEnabled=(((Buffer_2_progress->Mark()>0)&&(Buffer_2_called->Mark()==0)&&(Server_1_enabled->Mark()==1)&&(Server_2_enabled->Mark()==1)));
  return NewEnabled;
}

double Middleware_SANSAN::IA_Buffer_2_utilisationActivity::Weight(){ 
  return 1;
}

bool Middleware_SANSAN::IA_Buffer_2_utilisationActivity::ReactivationPredicate(){ 
  return false;
}

bool Middleware_SANSAN::IA_Buffer_2_utilisationActivity::ReactivationFunction(){ 
  return false;
}

double Middleware_SANSAN::IA_Buffer_2_utilisationActivity::SampleDistribution(){
  return 0;
}

double* Middleware_SANSAN::IA_Buffer_2_utilisationActivity::ReturnDistributionParameters(){
    return NULL;
}

int Middleware_SANSAN::IA_Buffer_2_utilisationActivity::Rank(){
  return 1;
}

BaseActionClass* Middleware_SANSAN::IA_Buffer_2_utilisationActivity::Fire(){
  if(GV_debug_flag==25)
{
        std::cerr << "\n\nMiddleware::IG_Buffer_2: The value of MW_ptr->Server_get_operation(Trans_ID,Server_ID) is " << MW_ptr->Server_get_operation(Middleware_ID->Mark(),2) << std::endl;
        std::cerr << "\n\nMiddleware::IG_Buffer_2 : The value of Buffer_2_progress->Mark() is " << Buffer_2_progress->Mark() << std::endl;     
        std::cerr << "\n\nMiddleware::IG_Buffer_2 : The value of MW_ptr->MW_get_Trans_progress(Middleware_ID->Mark(), 2) is " << MW_ptr->MW_get_Trans_progress(Middleware_ID->Mark(), 2) << std::endl;
}

/* Signal to Server 1 what the next operation should be */
Buffer_2_progress->Mark() = Buffer_2_progress->Mark() - 1;
Buffer_2_called->Mark() = 1;

/* Set the appropriate signal for the server to perform the client request */
//if((MW_ptr->Server_get_operation(Middleware_ID->Mark(),2)).compare(std::string("Begin"))==0)
//{
//    /* A begin edge is detected, so only the "Execute_Transaction" should be activated */
//    Execute_Transaction_2->Mark() = 1;
//    Request_Operation_Server_2->Mark() = 0;
//
//}else
{
    /* All other operations and edges require both flags to be activated */
    Execute_Transaction_2->Mark() = 1;
    Request_Operation_Server_2->Mark() = 1;    
}

/* Reset signals from client, if this is being sent to the faster server */
if(MW_ptr->MW_signal_server(Middleware_ID->Mark())==1)
{
    /* Yes, Server 2 is the faster server */
    Execute_Transaction_current->Mark() = 0;
    Request_Operation_Server_current->Mark() = 0;
}

  return this;
}

/*======================IA_Signal_ServerActivity========================*/


Middleware_SANSAN::IA_Signal_ServerActivity::IA_Signal_ServerActivity(){
  ActivityInitialize("IA_Signal_Server",6,Instantaneous , RaceEnabled, 10,1, false);
}

void Middleware_SANSAN::IA_Signal_ServerActivity::LinkVariables(){
  Signal_Server->Register(&Signal_Server_Mobius_Mark);
  Server_1_enabled->Register(&Server_1_enabled_Mobius_Mark);
  Request_Operation_Server_1->Register(&Request_Operation_Server_1_Mobius_Mark);
  Request_Operation_Server_current->Register(&Request_Operation_Server_current_Mobius_Mark);
  Execute_Transaction_1->Register(&Execute_Transaction_1_Mobius_Mark);
  Execute_Transaction_current->Register(&Execute_Transaction_current_Mobius_Mark);
  Server_2_enabled->Register(&Server_2_enabled_Mobius_Mark);
  Request_Operation_Server_2->Register(&Request_Operation_Server_2_Mobius_Mark);
  Execute_Transaction_2->Register(&Execute_Transaction_2_Mobius_Mark);
  Middleware_ID->Register(&Middleware_ID_Mobius_Mark);
}

bool Middleware_SANSAN::IA_Signal_ServerActivity::Enabled(){
  OldEnabled=NewEnabled;
  NewEnabled=(((Signal_Server->Mark()==1)));
  return NewEnabled;
}

double Middleware_SANSAN::IA_Signal_ServerActivity::Weight(){ 
  return 1;
}

bool Middleware_SANSAN::IA_Signal_ServerActivity::ReactivationPredicate(){ 
  return false;
}

bool Middleware_SANSAN::IA_Signal_ServerActivity::ReactivationFunction(){ 
  return false;
}

double Middleware_SANSAN::IA_Signal_ServerActivity::SampleDistribution(){
  return 0;
}

double* Middleware_SANSAN::IA_Signal_ServerActivity::ReturnDistributionParameters(){
    return NULL;
}

int Middleware_SANSAN::IA_Signal_ServerActivity::Rank(){
  return 1;
}

BaseActionClass* Middleware_SANSAN::IA_Signal_ServerActivity::Fire(){
  /* Stop the signal from being sent to the respective Server more than once */
Signal_Server->Mark() = 0;

/* Forward the signal for the next operation to the active Server */
if(Server_1_enabled->Mark())
{
    Request_Operation_Server_1->Mark() = Request_Operation_Server_current->Mark();
    Execute_Transaction_1->Mark() = Execute_Transaction_current->Mark();
}

if(Server_2_enabled->Mark())
{
    Request_Operation_Server_2->Mark() = Request_Operation_Server_current->Mark();
    Execute_Transaction_2->Mark() = Execute_Transaction_current->Mark();
}

/* Reset the signal from the Client */
//    Request_Operation_Server_current->Mark() = 0;
//    Execute_Transaction_current->Mark() = 0;

/* Reset flag preventing "Edge detection" from firing more than once */
//    Oper_Edge_detection_called->Mark()=0;

if(GV_debug_flag==22)
{
   cerr << "The Middleware::IG_Signal_Server gate has fired for Middleware " << Middleware_ID->Mark() <<  endl;
}
  return this;
}

/*======================IA_Results_SingleServerActivity========================*/


Middleware_SANSAN::IA_Results_SingleServerActivity::IA_Results_SingleServerActivity(){
  ActivityInitialize("IA_Results_SingleServer",7,Instantaneous , RaceEnabled, 13,4, false);
}

void Middleware_SANSAN::IA_Results_SingleServerActivity::LinkVariables(){
  Server_1_enabled->Register(&Server_1_enabled_Mobius_Mark);
  Server_2_enabled->Register(&Server_2_enabled_Mobius_Mark);
  Operation_Executed_Server_1->Register(&Operation_Executed_Server_1_Mobius_Mark);
  Operation_Executed_Server_2->Register(&Operation_Executed_Server_2_Mobius_Mark);
  Middleware_ID->Register(&Middleware_ID_Mobius_Mark);
  Operation_Executed_current->Register(&Operation_Executed_current_Mobius_Mark);
  Execute_Transaction_current->Register(&Execute_Transaction_current_Mobius_Mark);
  Execute_Transaction_1->Register(&Execute_Transaction_1_Mobius_Mark);
  Request_Operation_Server_current->Register(&Request_Operation_Server_current_Mobius_Mark);
  Request_Operation_Server_1->Register(&Request_Operation_Server_1_Mobius_Mark);
  Oper_Edge_detection_called->Register(&Oper_Edge_detection_called_Mobius_Mark);
  Execute_Transaction_2->Register(&Execute_Transaction_2_Mobius_Mark);
  Request_Operation_Server_2->Register(&Request_Operation_Server_2_Mobius_Mark);
}

bool Middleware_SANSAN::IA_Results_SingleServerActivity::Enabled(){
  OldEnabled=NewEnabled;
  NewEnabled=(((!((Server_1_enabled->Mark()==1)&&(Server_2_enabled->Mark()==1)))&&((Operation_Executed_Server_1->Mark()==1)||(Operation_Executed_Server_2->Mark()==1))));
  return NewEnabled;
}

double Middleware_SANSAN::IA_Results_SingleServerActivity::Weight(){ 
  return 1;
}

bool Middleware_SANSAN::IA_Results_SingleServerActivity::ReactivationPredicate(){ 
  return false;
}

bool Middleware_SANSAN::IA_Results_SingleServerActivity::ReactivationFunction(){ 
  return false;
}

double Middleware_SANSAN::IA_Results_SingleServerActivity::SampleDistribution(){
  return 0;
}

double* Middleware_SANSAN::IA_Results_SingleServerActivity::ReturnDistributionParameters(){
    return NULL;
}

int Middleware_SANSAN::IA_Results_SingleServerActivity::Rank(){
  return 1;
}

BaseActionClass* Middleware_SANSAN::IA_Results_SingleServerActivity::Fire(){
  if(GV_debug_flag==22)
{
   std::cerr << "Middleware_SAN::IG_Results_SingleServer: This output gate has been called for Middleware " << Middleware_ID->Mark() << endl;
}

/* Update the respective Client's shared memory with the results from the Operation execution */
if(Server_1_enabled->Mark())
{
    ClientObjects[Middleware_ID->Mark()-1]->set_Oper_Exec_Status(MW_ptr->MW_get_operation_result(Middleware_ID->Mark(),1));

if(GV_debug_flag==20)
{
   std::cerr << "Middleware_SAN::IG_Results_SingleServer: (mssg 2) This output gate has been called for Middleware " << Middleware_ID->Mark() << endl;
}

    /* Send a signal to the respective Client from the appropriate Server */
    Operation_Executed_current->Mark() = Operation_Executed_Server_1->Mark();   
    Operation_Executed_Server_1->Mark() = 0;
    Execute_Transaction_current->Mark() = Execute_Transaction_1->Mark();
    Request_Operation_Server_current->Mark() = Request_Operation_Server_1->Mark();

    /* In addition, if the current operation perfomed is a "Commit" or "Abort", then perform house-keeping */
    if(MW_ptr->MW_detect_Transaction_complete(Middleware_ID->Mark(), 1)/* Check for succesful transaction Termination */)
    {
       MW_ptr->MW_results_reset(Middleware_ID->Mark());
       MW_ptr->MW_buffer_reset(Middleware_ID->Mark());
       
       Execute_Transaction_1->Mark()=0;
       Request_Operation_Server_1->Mark()=0;

    }else
    {
        /* Update the Transaction progress for this server */
        MW_ptr->MW_update_Trans_progress(Middleware_ID->Mark(), 1);

    }

/* Reset flag preventing "Edge detection" from firing more than once */
    Oper_Edge_detection_called->Mark()=0;

}else if(Server_2_enabled->Mark())
{

if(GV_debug_flag==22)
{
   std::cerr << "Middleware_SAN::IG_Results_SingleServer: (mssg 3) This output gate has been called for Middleware " << Middleware_ID->Mark() << endl;
   
   std::cerr << "Middleware_SAN::IG_Results_SingleServer: The result of the last operation execution is " << MW_ptr->MW_get_operation_result(Middleware_ID->Mark(),2) << endl;
}

   ClientObjects[Middleware_ID->Mark()-1]->set_Oper_Exec_Status(MW_ptr->MW_get_operation_result(Middleware_ID->Mark(),2));

if(GV_debug_flag==22)
{
   std::cerr << "Middleware_SAN::IG_Results_SingleServer: (mssg 4) This output gate has been called for Middleware " << Middleware_ID->Mark() << endl;
}

    /* Send a signal to the respective Client from the appropriate Server */
    Operation_Executed_current->Mark() = Operation_Executed_Server_2->Mark();   
    Operation_Executed_Server_2->Mark() = 0;
    Execute_Transaction_current->Mark() = Execute_Transaction_2->Mark();
    Request_Operation_Server_current->Mark() = Request_Operation_Server_2->Mark();

    /* In addition, if the current operation perfomed is a "Commit" or "Abort", then perform house-keeping */
    if(MW_ptr->MW_detect_Transaction_complete(Middleware_ID->Mark(), 2)/* Check for succesful transaction Termination */)
    {
       MW_ptr->MW_results_reset(Middleware_ID->Mark());
       MW_ptr->MW_buffer_reset(Middleware_ID->Mark());

       Execute_Transaction_2->Mark()=0;
       Request_Operation_Server_2->Mark()=0;

    }else
    {
        /* Update the Transaction progress for this server */
        MW_ptr->MW_update_Trans_progress(Middleware_ID->Mark(), 2);
    }

/* Reset flag preventing "Edge detection" from firing more than once */
    Oper_Edge_detection_called->Mark()=0;

if(GV_debug_flag==20)
{
   std::cerr << "Middleware_SAN::IG_Results_SingleServer: (mssg 5) This output gate has been called for Middleware " << Middleware_ID->Mark() << endl;
}

}


  return this;
}

/*======================IA_ExceptionActivity========================*/


Middleware_SANSAN::IA_ExceptionActivity::IA_ExceptionActivity(){
  ActivityInitialize("IA_Exception",8,Instantaneous , RaceEnabled, 12,6, false);
}

void Middleware_SANSAN::IA_ExceptionActivity::LinkVariables(){
  Exception->Register(&Exception_Mobius_Mark);
  Operation_Executed_Server_1->Register(&Operation_Executed_Server_1_Mobius_Mark);
  Operation_Executed_Server_2->Register(&Operation_Executed_Server_2_Mobius_Mark);
  Request_Operation_Server_current->Register(&Request_Operation_Server_current_Mobius_Mark);
  Execute_Transaction_current->Register(&Execute_Transaction_current_Mobius_Mark);
  Oper_Edge_detection_called->Register(&Oper_Edge_detection_called_Mobius_Mark);
  Middleware_ID->Register(&Middleware_ID_Mobius_Mark);
  Buffer_1_progress->Register(&Buffer_1_progress_Mobius_Mark);
  Buffer_2_progress->Register(&Buffer_2_progress_Mobius_Mark);
  Operation_Executed_current->Register(&Operation_Executed_current_Mobius_Mark);
  Execute_Transaction_1->Register(&Execute_Transaction_1_Mobius_Mark);
  Request_Operation_Server_1->Register(&Request_Operation_Server_1_Mobius_Mark);
}

bool Middleware_SANSAN::IA_ExceptionActivity::Enabled(){
  OldEnabled=NewEnabled;
  NewEnabled=(((Exception->Mark()==1)&&(((Operation_Executed_Server_1->Mark()==1)&&(Operation_Executed_Server_2->Mark()==1))||(((Request_Operation_Server_current->Mark()==1)||(Execute_Transaction_current->Mark()==1))&&(Oper_Edge_detection_called->Mark()==0)))
/* This code needs to fire whenever the Server that did not throw the exception 
 * attempts to perform a new operation
 */));
  return NewEnabled;
}

double Middleware_SANSAN::IA_ExceptionActivity::Weight(){ 
  return 1;
}

bool Middleware_SANSAN::IA_ExceptionActivity::ReactivationPredicate(){ 
  return false;
}

bool Middleware_SANSAN::IA_ExceptionActivity::ReactivationFunction(){ 
  return false;
}

double Middleware_SANSAN::IA_ExceptionActivity::SampleDistribution(){
  return 0;
}

double* Middleware_SANSAN::IA_ExceptionActivity::ReturnDistributionParameters(){
    return NULL;
}

int Middleware_SANSAN::IA_ExceptionActivity::Rank(){
  return 1;
}

BaseActionClass* Middleware_SANSAN::IA_ExceptionActivity::Fire(){
  if(GV_debug_flag==26)
{
    std::cerr << "DIDERO_PC_General:Middleware_SAN.cpp::IG_Exception : An exception is being handled on both servers for Client " << Middleware_ID->Mark() << std::endl;
    std::cerr << "DIDERO_PC_General:Middleware_SAN.cpp::IG_Exception : The value of Execute_Transaction_current->Mark() for Client " << Middleware_ID->Mark() << " is " << Execute_Transaction_current->Mark() << std::endl;
}

/* Reset the Buffers and send exception to respective Client */
Buffer_1_progress->Mark() = 0;
Buffer_2_progress->Mark() = 0;

/* Store exception in respective Client's shared memory space and signal Client */
ClientObjects[Middleware_ID->Mark()-1]->set_Oper_Exec_Status(std::string("Abort"));

/* Update the Transaction progress for this server */
//MW_ptr->MW_update_Trans_progress(Middleware_ID->Mark(), 1);
//MW_ptr->MW_update_Trans_progress(Middleware_ID->Mark(), 2);

/* Reset the buffer and results data structures for this Middleware "thread" */
MW_ptr->MW_results_reset(Middleware_ID->Mark());
MW_ptr->MW_buffer_reset(Middleware_ID->Mark());

Request_Operation_Server_current->Mark() = 0;
Operation_Executed_Server_1->Mark() = 0;
Operation_Executed_Server_2->Mark() = 0;
Operation_Executed_current->Mark() = 1;
Exception->Mark()=0;

/* Reset flag preventing "Edge detection" from firing more than once */
Oper_Edge_detection_called->Mark()=0;

/* Set the shared Client-side signals; it doesn't matter which Server-side shared signals we 
 * use for setting
 */
Execute_Transaction_current->Mark() = Execute_Transaction_1->Mark();
Request_Operation_Server_current->Mark() = Request_Operation_Server_1->Mark();

  return this;
}

/*======================TA_Mutex_poolActivity========================*/


Middleware_SANSAN::TA_Mutex_poolActivity::TA_Mutex_poolActivity(){
  ActivityInitialize("TA_Mutex_pool",9,Instantaneous , RaceEnabled, 10,7, false);
}

void Middleware_SANSAN::TA_Mutex_poolActivity::LinkVariables(){
  Mutex_pool->Register(&Mutex_pool_Mobius_Mark);
  Mutex_requested->Register(&Mutex_requested_Mobius_Mark);
  Mutex_granted->Register(&Mutex_granted_Mobius_Mark);
  Server_1_enabled->Register(&Server_1_enabled_Mobius_Mark);
  Server_2_enabled->Register(&Server_2_enabled_Mobius_Mark);
  Exception->Register(&Exception_Mobius_Mark);
  Middleware_ID->Register(&Middleware_ID_Mobius_Mark);
  Request_Operation_Server_1->Register(&Request_Operation_Server_1_Mobius_Mark);
  Request_Operation_Server_current->Register(&Request_Operation_Server_current_Mobius_Mark);
  Execute_Transaction_1->Register(&Execute_Transaction_1_Mobius_Mark);
  Execute_Transaction_current->Register(&Execute_Transaction_current_Mobius_Mark);
  Request_Operation_Server_2->Register(&Request_Operation_Server_2_Mobius_Mark);
  Execute_Transaction_2->Register(&Execute_Transaction_2_Mobius_Mark);
}

bool Middleware_SANSAN::TA_Mutex_poolActivity::Enabled(){
  OldEnabled=NewEnabled;
  NewEnabled=(((Mutex_pool->Mark()>0)&&(Mutex_requested->Mark()==1)&&(Mutex_granted->Mark()==0)&&(Server_1_enabled->Mark()==1)&&(Server_2_enabled->Mark()==1)&&(Exception->Mark()==0)&&((MW_ptr->MW_get_Trans_progress(Middleware_ID->Mark(), 1) == MW_ptr->MW_get_Trans_progress(Middleware_ID->Mark(), 2))||((ClientObjects[Middleware_ID->Mark()-1]->get_Shared_Data_Operation()).compare(std::string("Abort"))==0))));
  return NewEnabled;
}

double Middleware_SANSAN::TA_Mutex_poolActivity::Weight(){ 
  return 1;
}

bool Middleware_SANSAN::TA_Mutex_poolActivity::ReactivationPredicate(){ 
  return false;
}

bool Middleware_SANSAN::TA_Mutex_poolActivity::ReactivationFunction(){ 
  return false;
}

double Middleware_SANSAN::TA_Mutex_poolActivity::SampleDistribution(){
  return 0;
}

double* Middleware_SANSAN::TA_Mutex_poolActivity::ReturnDistributionParameters(){
    return NULL;
}

int Middleware_SANSAN::TA_Mutex_poolActivity::Rank(){
  return 1;
}

BaseActionClass* Middleware_SANSAN::TA_Mutex_poolActivity::Fire(){
  Mutex_pool->Mark()=Mutex_pool->Mark()-1;
Mutex_requested->Mark()=0;
Mutex_granted->Mark()=Middleware_ID->Mark();



/* Forward the signal for the next operation to both Servers */

    Request_Operation_Server_1->Mark() = Request_Operation_Server_current->Mark();
    Execute_Transaction_1->Mark() = Execute_Transaction_current->Mark();

    Request_Operation_Server_2->Mark() = Request_Operation_Server_current->Mark();
    Execute_Transaction_2->Mark() = Execute_Transaction_current->Mark();

/* Reset the signal from the Client */
//    Request_Operation_Server_current->Mark() = 0;
//    Execute_Transaction_current->Mark() = 0;

if(GV_debug_flag==27)
{
   cerr << "The Middleware::IG_Mutex_pool gate has fired for Middleware " << Middleware_ID->Mark() << " at time " << BaseModelClass::LastActionTime <<   endl;
}
  return this;
}

/*======================TA_ResultsActivity========================*/

Middleware_SANSAN::TA_ResultsActivity::TA_ResultsActivity(){
  TheDistributionParameters = new double[1];
  ActivityInitialize("TA_Results",0,Deterministic, RaceEnabled, 20,7, false);
}

Middleware_SANSAN::TA_ResultsActivity::~TA_ResultsActivity(){
  delete[] TheDistributionParameters;
}

void Middleware_SANSAN::TA_ResultsActivity::LinkVariables(){
  Mutex_granted->Register(&Mutex_granted_Mobius_Mark);
  Middleware_ID->Register(&Middleware_ID_Mobius_Mark);
  Operation_Executed_Server_1->Register(&Operation_Executed_Server_1_Mobius_Mark);
  Operation_Executed_Server_2->Register(&Operation_Executed_Server_2_Mobius_Mark);
  Server_1_enabled->Register(&Server_1_enabled_Mobius_Mark);
  Server_2_enabled->Register(&Server_2_enabled_Mobius_Mark);
  Exception->Register(&Exception_Mobius_Mark);
  Execute_Transaction_current->Register(&Execute_Transaction_current_Mobius_Mark);
  Operation_Executed_current->Register(&Operation_Executed_current_Mobius_Mark);
  Request_Operation_Server_current->Register(&Request_Operation_Server_current_Mobius_Mark);
  Request_Operation_Server_1->Register(&Request_Operation_Server_1_Mobius_Mark);
  Execute_Transaction_1->Register(&Execute_Transaction_1_Mobius_Mark);
  Oper_Edge_detection_called->Register(&Oper_Edge_detection_called_Mobius_Mark);
  Request_Operation_Server_2->Register(&Request_Operation_Server_2_Mobius_Mark);
  Execute_Transaction_2->Register(&Execute_Transaction_2_Mobius_Mark);
  Buffer_Operations->Register(&Buffer_Operations_Mobius_Mark);
  Buffer_1_called->Register(&Buffer_1_called_Mobius_Mark);
  Buffer_1_progress->Register(&Buffer_1_progress_Mobius_Mark);
  Buffer_2_called->Register(&Buffer_2_called_Mobius_Mark);
  Buffer_2_progress->Register(&Buffer_2_progress_Mobius_Mark);
  Wait_for_slower_server->Register(&Wait_for_slower_server_Mobius_Mark);
}

bool Middleware_SANSAN::TA_ResultsActivity::Enabled(){
  OldEnabled=NewEnabled;
  NewEnabled=(((Mutex_granted->Mark()!=Middleware_ID->Mark())&&((Operation_Executed_Server_1->Mark()==1)||(Operation_Executed_Server_2->Mark()==1))&&(Server_1_enabled->Mark()==1)&&(Server_2_enabled->Mark()==1)&&(Exception->Mark()==0)));
  return NewEnabled;
}

double Middleware_SANSAN::TA_ResultsActivity::DeterministicParamValue(){
  return 1e-23;
  return 1.0;  // default rate if none is specified
}

double Middleware_SANSAN::TA_ResultsActivity::Weight(){ 
  return 1;
}

bool Middleware_SANSAN::TA_ResultsActivity::ReactivationPredicate(){ 
  return false;
}

bool Middleware_SANSAN::TA_ResultsActivity::ReactivationFunction(){ 
  return false;
}

double Middleware_SANSAN::TA_ResultsActivity::SampleDistribution(){
  return 1e-23;
}

double* Middleware_SANSAN::TA_ResultsActivity::ReturnDistributionParameters(){
  TheDistributionParameters[0] = DeterministicParamValue();
  return TheDistributionParameters;
}

int Middleware_SANSAN::TA_ResultsActivity::Rank(){
  return 1;
}

BaseActionClass* Middleware_SANSAN::TA_ResultsActivity::Fire(){
  if(GV_debug_flag==26)
{
    cerr << "IG_Results_MultipleServers : A result has been returned for Client " << Middleware_ID->Mark() << endl;
    std::cerr << "DIDERO_PC_General:Middleware_SAN.cpp::IG_Results_MultipleServers : The value of Execute_Transaction_current->Mark() for Client " << Middleware_ID->Mark() << " is " << Execute_Transaction_current->Mark() << std::endl;
}

/* Update the respective Client's shared memory space with the result */
if( ( (MW_ptr->MW_get_Trans_progress(Middleware_ID->Mark(), 1) > MW_ptr->MW_get_Trans_progress(Middleware_ID->Mark(), 2) )&&(Operation_Executed_Server_1->Mark()==1) )||((MW_ptr->MW_get_Trans_progress(Middleware_ID->Mark(), 1) < MW_ptr->MW_get_Trans_progress(Middleware_ID->Mark(), 2) )&&(Operation_Executed_Server_2->Mark()==1)))
{		 
    /* The faster Server has signalled it has executed the operation */
    if(MW_ptr->MW_get_Trans_progress(Middleware_ID->Mark(), 1) > MW_ptr->MW_get_Trans_progress(Middleware_ID->Mark(), 2) )
    {

        if(GV_debug_flag==25)
        {
           cerr << "IG_Results_MultipleServers : Server 1, the faster server, has returned a result for Client " << Middleware_ID->Mark() << endl;
        }
 
		/* If an exception was raised then wait for slower server before reseting flags and returning exception to Client */
        if(MW_ptr->MW_detect_exception(Middleware_ID->Mark(),1)/* Exception has occurred */)
        {
            /* Signal an Exception has occurred; intercept the result of the slower Server */
            Exception->Mark() = 1;
			if(GV_debug_flag==26)
			{
			   cerr << "IG_Results_MultipleServers : a) Server 1 has returned an exception for Client " << Middleware_ID->Mark() << " at time " << BaseModelClass::LastActionTime << endl;
			   std::cerr << "DIDERO_PC_General:Middleware_SAN.cpp::IG_Results_MultipleServers : The value of Execute_Transaction_current->Mark() for Client " << Middleware_ID->Mark() << " is " << Execute_Transaction_current->Mark() << std::endl;
			}			
			
        }else
        {
            /* Update the respective Client's shared memory space with Server 1's result */
            ClientObjects[Middleware_ID->Mark()-1]->set_Oper_Exec_Status(MW_ptr->MW_get_operation_result(Middleware_ID->Mark(),1));
            
            /* Update the Transaction progress for this server */
            MW_ptr->MW_update_Trans_progress(Middleware_ID->Mark(), 1);
            
            Operation_Executed_Server_1->Mark() = 0;
            Operation_Executed_current->Mark() = 1;
            Request_Operation_Server_current->Mark() = Request_Operation_Server_1->Mark();
            Execute_Transaction_current->Mark() = Execute_Transaction_1->Mark();

            /* Reset flag preventing "Edge detection" from firing more than once */
            Oper_Edge_detection_called->Mark()=0;
        }
        
    }else
    {

         if(GV_debug_flag==25)
         {
            cerr << "IG_Results_MultipleServers : Server 2, the faster server, has returned a result for Client " << Middleware_ID->Mark() << endl;
         }
        /* If an exception was raised then wait for slower server before reseting flags and returning exception to Client */
        if(MW_ptr->MW_detect_exception(Middleware_ID->Mark(),2)/* Exception has occurred */)
        {
            /* Signal an Exception has occurred; intercept the result of the slower Server */
            Exception->Mark() = 1;
			if(GV_debug_flag==26)
			{
			   cerr << "IG_Results_MultipleServers : Server 2 has returned an exception for Client " << Middleware_ID->Mark() << endl;
			}			
			

        }else
        {
            /* Update the respective Client's shared memory space with Server 2's result */
            ClientObjects[Middleware_ID->Mark()-1]->set_Oper_Exec_Status(MW_ptr->MW_get_operation_result(Middleware_ID->Mark(),2));

            /* Update the Transaction progress for this server */
            MW_ptr->MW_update_Trans_progress(Middleware_ID->Mark(), 2);

            Operation_Executed_Server_2->Mark() = 0;
            Operation_Executed_current->Mark() = 1;
            Request_Operation_Server_current->Mark() = Request_Operation_Server_2->Mark();
            Execute_Transaction_current->Mark() = Execute_Transaction_2->Mark(); 
            /* Reset flag preventing "Edge detection" from firing more than once */
            Oper_Edge_detection_called->Mark()=0;

        }
    }

}else
{
    /* The slower server has signalled it has executed the operation */
    if((MW_ptr->MW_get_Trans_progress(Middleware_ID->Mark(), 1) < MW_ptr->MW_get_Trans_progress(Middleware_ID->Mark(), 2))&&(Operation_Executed_Server_1->Mark() == 1))
    {
         if(GV_debug_flag==25)
         {
            cerr << "IG_Results_MultipleServers : Server 1 is the slower server returning a result for Client " << Middleware_ID->Mark() << endl;
         }	
	
        /* If an exception was raised then wait for the faster server before reseting flags and returning exception to Client */
        if(MW_ptr->MW_detect_exception(Middleware_ID->Mark(),1)/* Exception has occurred */)
        {
            /* Signal an Exception has occurred; intercept the result of the faster Server */
            Exception->Mark() = 1;

			if(GV_debug_flag==26)
			{
			   cerr << "IG_Results_MultipleServers : b) Server 1 has returned an exception for Client " << Middleware_ID->Mark() << endl;
			}			
			

        }else
        {
			 if(GV_debug_flag==25)
			 {
				cerr << "IG_Results_MultipleServers : Server 1, the slower server, has returned a result for Client " << Middleware_ID->Mark() << endl;
			 }		
		
            /* Perform the next operation */
            Operation_Executed_Server_1->Mark() = 0;
			
			 if(GV_debug_flag==25)
			 {
				cerr << "IG_Results_MultipleServers : The value of Oper_Edge_detection_called->Mark() for Client " << Middleware_ID->Mark() << " is " << Oper_Edge_detection_called->Mark() << endl;
				cerr << "IG_Results_MultipleServers : The value of Buffer_Operations->Mark() for Client " << Middleware_ID->Mark() << " is " << Buffer_Operations->Mark() << endl;				
				cerr << "IG_Results_MultipleServers : The value of MW_ptr->MW_get_Trans_progress(Middleware_ID->Mark(), 2) for Client " << Middleware_ID->Mark() << " is " << MW_ptr->MW_get_Trans_progress(Middleware_ID->Mark(), 2) << endl;				
				cerr << "IG_Results_MultipleServers : The value of MW_ptr->MW_get_Trans_progress(Middleware_ID->Mark(), 1) for Client " << Middleware_ID->Mark() << " is " << MW_ptr->MW_get_Trans_progress(Middleware_ID->Mark(), 1) << endl;								
				cerr << "IG_Results_MultipleServers : The value of MW_ptr->MW_detect_edge(Middleware_ID->Mark()) for Client " << Middleware_ID->Mark() << " is " << MW_ptr->MW_detect_edge(Middleware_ID->Mark()) << endl;				
			 }			
			
            //if(((Buffer_1_progress->Mark()>0)&&(Oper_Edge_detection_called->Mark()==1)&&(Buffer_Operations->Mark()==0))||())
			if(!(((MW_ptr->MW_get_Trans_progress(Middleware_ID->Mark(), 1) + 1) == MW_ptr->MW_get_Trans_progress(Middleware_ID->Mark(), 2))&&(MW_ptr->MW_detect_edge(Middleware_ID->Mark()))))
			{
				Buffer_1_called->Mark() = 0;
			}
			
			 if(GV_debug_flag==25)
			 {
				cerr << "IG_Results_MultipleServers : The value of the IG_Buffer_1 predicate for Client " << Middleware_ID->Mark() << " is " << ((Buffer_1_progress->Mark()>0)&&(Buffer_1_called->Mark()==0)&&(Server_1_enabled->Mark()==1)&&(Server_2_enabled->Mark()==1)) << endl;
				cerr << "IG_Results_MultipleServers : The value of Buffer_1_progress->Mark() for Client " << Middleware_ID->Mark() << " is " << Buffer_1_progress->Mark() << endl;
				cerr << "IG_Results_MultipleServers : The value of Buffer_1_called->Mark() for Client " << Middleware_ID->Mark() << " is " << Buffer_1_called->Mark() << endl;				
			}
			
            /* Update the Transaction progress for this server */
            MW_ptr->MW_update_Trans_progress(Middleware_ID->Mark(), 1);			
        }
    }else if((MW_ptr->MW_get_Trans_progress(Middleware_ID->Mark(), 1) > MW_ptr->MW_get_Trans_progress(Middleware_ID->Mark(), 2) )&&(Operation_Executed_Server_2->Mark() == 1))
    {
	
         if(GV_debug_flag==25)
         {
            cerr << "IG_Results_MultipleServers : Server 2 is the slower server returning a result for Client " << Middleware_ID->Mark() << endl;
         }
		 
        /* If an exception was raised then wait for the faster server before reseting flags and returning exception to Client */
        if(MW_ptr->MW_detect_exception(Middleware_ID->Mark(),2)/* Exception has occurred */)
        {
            /* Signal an Exception has occurred; intercept the result of the faster Server */
            Exception->Mark() = 1;
			if(GV_debug_flag==26)
			{
			   cerr << "IG_Results_MultipleServers : Server 2 has returned an exception for Client " << Middleware_ID->Mark() << endl;
			}			
			

        }else
        {
			 if(GV_debug_flag==25)
			 {
				cerr << "IG_Results_MultipleServers : Server 2, the slower server, has returned a result for Client " << Middleware_ID->Mark() << endl;
			 }		
            /* Perform the next operation */
            Operation_Executed_Server_2->Mark() = 0;

			 if(GV_debug_flag==25)
			 {
				cerr << "IG_Results_MultipleServers : The value of Oper_Edge_detection_called->Mark() for Client " << Middleware_ID->Mark() << " is " << Oper_Edge_detection_called->Mark() << endl;
				cerr << "IG_Results_MultipleServers : The value of Buffer_Operations->Mark() for Client " << Middleware_ID->Mark() << " is " << Buffer_Operations->Mark() << endl;				
				cerr << "IG_Results_MultipleServers : The value of MW_ptr->MW_get_Trans_progress(Middleware_ID->Mark(), 2) for Client " << Middleware_ID->Mark() << " is " << MW_ptr->MW_get_Trans_progress(Middleware_ID->Mark(), 2) << endl;				
				cerr << "IG_Results_MultipleServers : The value of MW_ptr->MW_get_Trans_progress(Middleware_ID->Mark(), 1) for Client " << Middleware_ID->Mark() << " is " << MW_ptr->MW_get_Trans_progress(Middleware_ID->Mark(), 1) << endl;								
				cerr << "IG_Results_MultipleServers : The value of MW_ptr->MW_detect_edge(Middleware_ID->Mark()) for Client " << Middleware_ID->Mark() << " is " << MW_ptr->MW_detect_edge(Middleware_ID->Mark()) << endl;								
			}			
			
            //if((Buffer_2_progress->Mark()>0)&&(Oper_Edge_detection_called->Mark()==1)&&(Buffer_Operations->Mark()==0))
			if(!(( (MW_ptr->MW_get_Trans_progress(Middleware_ID->Mark(), 2) + 1) == MW_ptr->MW_get_Trans_progress(Middleware_ID->Mark(), 1))&&(MW_ptr->MW_detect_edge(Middleware_ID->Mark()))))
			{
				Buffer_2_called->Mark() = 0;
			}
			
			 if(GV_debug_flag==25)
			 {
				cerr << "IG_Results_MultipleServers : The value of the IG_Buffer_2 predicate for Client " << Middleware_ID->Mark() << " is " << ((Buffer_2_progress->Mark()>0)&&(Buffer_2_called->Mark()==0)&&(Server_1_enabled->Mark()==1)&&(Server_2_enabled->Mark()==1)) << endl;
				cerr << "IG_Results_MultipleServers : The value of Buffer_2_progress->Mark() for Client " << Middleware_ID->Mark() << " is " << Buffer_2_progress->Mark() << endl;
				cerr << "IG_Results_MultipleServers : The value of Buffer_2_called->Mark() for Client " << Middleware_ID->Mark() << " is " << Buffer_2_called->Mark() << endl;				
			 }			
			
            /* Update the Transaction progress for this server */
            MW_ptr->MW_update_Trans_progress(Middleware_ID->Mark(), 2);
        }
    }else
    {
        /* Both Servers have completed the same number of operations so far.
         * This is due to one of the following:
         * 1) The Client has not sent a new request yet;
         * 2) Both Servers were executing a transaction edge; 
         */

         if(GV_debug_flag==25)
         {
            cerr << "IG_Results_MultipleServers : both Server 1 and Server 2 are returning results for Client " << Middleware_ID->Mark() << endl;
         }
		 
		 //MW_ptr->MW_get_Trans_progress(Middleware_ID->Mark(), 1) < MW_ptr->MW_get_Trans_progress(Middleware_ID->Mark(), 2)
		 if(Operation_Executed_Server_1->Mark() == 1)
		 {
			 if(GV_debug_flag==25)
			 {
				cerr << "IG_Results_MultipleServers : Server 1's result for Client " << Middleware_ID->Mark() << " is being processed. What about Server 2?" << endl;
			 }		 
            if(MW_ptr->MW_detect_exception(Middleware_ID->Mark(),1))
            {
                  /* If one of the servers has thrown an exception */
                  /* Signal an Exception has occurred; intercept the result of the faster Server */
                  Exception->Mark() = 1;
				  
			if(GV_debug_flag==26)
			{
			   cerr << "IG_Results_MultipleServers : c) Server 1 has returned an exception for Client " << Middleware_ID->Mark() << endl;
			}			
				  
				  
            }else if((MW_ptr->MW_detect_edge(Middleware_ID->Mark()))&&(Operation_Executed_Server_2->Mark() == 1))
			{
				   /* If this is a succesfully completed transaction edge */
				   /* Update the respective Client with the result from both servers */
					 ClientObjects[Middleware_ID->Mark()-1]->set_Oper_Exec_Status(MW_ptr->MW_get_operation_result(Middleware_ID->Mark(),1));
					 Operation_Executed_Server_1->Mark() = 0;
					 Operation_Executed_Server_2->Mark() = 0;
					 Operation_Executed_current->Mark() = 1;
					 Request_Operation_Server_current->Mark() = Request_Operation_Server_1->Mark();
					 Execute_Transaction_current->Mark() = Execute_Transaction_1->Mark();

					 if(GV_debug_flag==25)
					 {
						 cerr << "IG_Results_MultipleServers : An EDGE result has been returned for Client " << Middleware_ID->Mark() << " at time " << BaseModelClass::LastActionTime <<  endl;
						 cerr << "IG_Results_MultipleServers : The result returned for Client " << Middleware_ID->Mark() << " from Server 1 is " << MW_ptr->MW_get_operation_result(Middleware_ID->Mark(),1) << endl;
						 cerr << "IG_Results_MultipleServers : The result returned for Client " << Middleware_ID->Mark() << " from Server 2 is " << MW_ptr->MW_get_operation_result(Middleware_ID->Mark(),2) << endl;
					 }

				   /* In addition, if the current operation perfomed is a "Commit" or "Abort", then perform house-keeping */
				   if(MW_ptr->MW_detect_Transaction_complete(Middleware_ID->Mark(), 1)/* Check for succesful transaction Termination */)
				   {
						if(GV_debug_flag==26)
						{
							cerr << "IG_Results_MultipleServers : The result returned for Client " << Middleware_ID->Mark() << " from Server 1 is " << MW_ptr->MW_get_operation_result(Middleware_ID->Mark(),1) << endl;
							cerr << "IG_Results_MultipleServers : The result returned for Client " << Middleware_ID->Mark() << " from Server 2 is " << MW_ptr->MW_get_operation_result(Middleware_ID->Mark(),2) << endl;
						}				   
				   
					   Buffer_1_progress->Mark()=0;
					   Buffer_2_progress->Mark()=0;
					   MW_ptr->MW_results_reset(Middleware_ID->Mark());
					   MW_ptr->MW_buffer_reset(Middleware_ID->Mark());
				       Request_Operation_Server_1->Mark()=0;
					   Execute_Transaction_1->Mark()=0;
					   Request_Operation_Server_2->Mark()=0;
					   Execute_Transaction_2->Mark()=0;					 
					   
				   }else
				   {
					   /* Update the Transaction progress for this server */
					   MW_ptr->MW_update_Trans_progress(Middleware_ID->Mark(), 1);
					   MW_ptr->MW_update_Trans_progress(Middleware_ID->Mark(), 2);
				   }


				/* Reset flag preventing "Edge detection" from firing more than once */
				Oper_Edge_detection_called->Mark()=0;				
			}else if((MW_ptr->MW_detect_edge(Middleware_ID->Mark()))&&(Operation_Executed_Server_2->Mark() == 0)&&(Wait_for_slower_server->Mark() == 1))
			{
				/* Reset the flag indicating that the faster server has already returned */
				Wait_for_slower_server->Mark() = 0;

				   /* If this is a succesfully completed transaction edge */
				   /* Update the respective Client with the result from both servers */
					 ClientObjects[Middleware_ID->Mark()-1]->set_Oper_Exec_Status(MW_ptr->MW_get_operation_result(Middleware_ID->Mark(),1));
					 Operation_Executed_Server_1->Mark() = 0;
					 Operation_Executed_Server_2->Mark() = 0;
					 Operation_Executed_current->Mark() = 1;
					 Request_Operation_Server_current->Mark() = Request_Operation_Server_1->Mark();
					 Execute_Transaction_current->Mark() = Execute_Transaction_1->Mark();

					 if(GV_debug_flag==25)
					 {
						 cerr << "IG_Results_MultipleServers : An EDGE result has been returned for Client " << Middleware_ID->Mark() << " at time " << BaseModelClass::LastActionTime <<  endl;
						 cerr << "IG_Results_MultipleServers : The result returned for Client " << Middleware_ID->Mark() << " from Server 1 is " << MW_ptr->MW_get_operation_result(Middleware_ID->Mark(),1) << endl;
						 cerr << "IG_Results_MultipleServers : The result returned for Client " << Middleware_ID->Mark() << " from Server 2 is " << MW_ptr->MW_get_operation_result(Middleware_ID->Mark(),2) << endl;
					 }

				   /* In addition, if the current operation perfomed is a "Commit" or "Abort", then perform house-keeping */
				   if(MW_ptr->MW_detect_Transaction_complete(Middleware_ID->Mark(), 1)/* Check for succesful transaction Termination */)
				   {
						if(GV_debug_flag==26)
						{
							cerr << "IG_Results_MultipleServers : The result returned for Client " << Middleware_ID->Mark() << " from Server 1 is " << MW_ptr->MW_get_operation_result(Middleware_ID->Mark(),1) << endl;
							cerr << "IG_Results_MultipleServers : The result returned for Client " << Middleware_ID->Mark() << " from Server 2 is " << MW_ptr->MW_get_operation_result(Middleware_ID->Mark(),2) << endl;
						}				   				   
					   Buffer_1_progress->Mark()=0;
					   Buffer_2_progress->Mark()=0;
					   MW_ptr->MW_results_reset(Middleware_ID->Mark());
					   MW_ptr->MW_buffer_reset(Middleware_ID->Mark());
				       Request_Operation_Server_1->Mark()=0;
					   Execute_Transaction_1->Mark()=0;
					   Request_Operation_Server_2->Mark()=0;
					   Execute_Transaction_2->Mark()=0;					 					   
					   
				   }else
				   {
					   /* Update the Transaction progress for this server */
					   MW_ptr->MW_update_Trans_progress(Middleware_ID->Mark(), 1);
					   MW_ptr->MW_update_Trans_progress(Middleware_ID->Mark(), 2);
				   }


				/* Reset flag preventing "Edge detection" from firing more than once */
				Oper_Edge_detection_called->Mark()=0;								
				
			}else if((MW_ptr->MW_detect_edge(Middleware_ID->Mark()))&&(Operation_Executed_Server_2->Mark() == 0)&&(Wait_for_slower_server->Mark() == 0))
			{
				/* Set the flag indicating that the slower server should be waited for  */
				Wait_for_slower_server->Mark() = 1;
				
				/* Set the Operation executed flag to zero, to prevent this gate from firing more than once */
				Operation_Executed_Server_1->Mark() = 0;
				
			}else
			{
				/* If other server is ready and an exception from the other server was not thrown */
				if((Operation_Executed_Server_2->Mark() == 1)&&(!(MW_ptr->MW_detect_exception(Middleware_ID->Mark(),2))))
				{
					if(GV_debug_flag==25)
					{
						cerr << "IG_Results_MultipleServers : Server 1 and 2's results for Client " << Middleware_ID->Mark() << " are being processed" << endl;
					}
					
					/* send results to Client and wait for next operation */
					/* Update the respective Client's shared memory space with Server 1's result */
					ClientObjects[Middleware_ID->Mark()-1]->set_Oper_Exec_Status(MW_ptr->MW_get_operation_result(Middleware_ID->Mark(),1));
					
					/* Update the Transaction progress for the servers */
					MW_ptr->MW_update_Trans_progress(Middleware_ID->Mark(), 1);					
					MW_ptr->MW_update_Trans_progress(Middleware_ID->Mark(), 2);
					
					Operation_Executed_Server_1->Mark() = 0;
					Operation_Executed_Server_2->Mark() = 0;					
					Operation_Executed_current->Mark() = 1;
					Request_Operation_Server_current->Mark() = Request_Operation_Server_1->Mark();
					Execute_Transaction_current->Mark() = Execute_Transaction_1->Mark();

					/* Reset flag preventing "Edge detection" from firing more than once */
					Oper_Edge_detection_called->Mark()=0;				
				}else if((Operation_Executed_Server_2->Mark() == 1)&&(MW_ptr->MW_detect_exception(Middleware_ID->Mark(),2)))
				{
					/* If one of the servers has thrown an exception */
					/* Signal an Exception has occurred; intercept the result of the faster Server */
					Exception->Mark() = 1;	
					if(GV_debug_flag==26)
					{
					   cerr << "IG_Results_MultipleServers : Server 2 has returned an exception for Client " << Middleware_ID->Mark() << endl;
					}			

					
				}else if(Operation_Executed_Server_2->Mark() == 0)
				{

					 if(GV_debug_flag==25)
					 {
						cerr << "IG_Results_MultipleServers : Server 1's result for Client " << Middleware_ID->Mark() << " is being processed before Server 2" << endl;
					 }
					 
					/* send results to Client and wait for next operation */
					/* Update the respective Client's shared memory space with Server 1's result */
					ClientObjects[Middleware_ID->Mark()-1]->set_Oper_Exec_Status(MW_ptr->MW_get_operation_result(Middleware_ID->Mark(),1));
					
					/* Update the Transaction progress for the servers */
					MW_ptr->MW_update_Trans_progress(Middleware_ID->Mark(), 1);
					
					Operation_Executed_Server_1->Mark() = 0;					
					Operation_Executed_current->Mark() = 1;
					Request_Operation_Server_current->Mark() = Request_Operation_Server_1->Mark();
					Execute_Transaction_current->Mark() = Execute_Transaction_1->Mark();

					/* Reset flag preventing "Edge detection" from firing more than once */
					Oper_Edge_detection_called->Mark()=0;									
				}
			}
		 }
		 
		 if(Operation_Executed_Server_2->Mark() == 1)
		 {
			 if(GV_debug_flag==25)
			 {
				cerr << "IG_Results_MultipleServers : Server 2's result for Client " << Middleware_ID->Mark() << " is being processed. What about Server 1?" << endl;
			 }
			 
            if(MW_ptr->MW_detect_exception(Middleware_ID->Mark(),2))
            {
                  /* If one of the servers has thrown an exception */
                  /* Signal an Exception has occurred; intercept the result of the faster Server */
                  Exception->Mark() = 1;
				  
				if(GV_debug_flag==26)
				{
				   cerr << "IG_Results_MultipleServers : Server 2 has returned an exception for Client " << Middleware_ID->Mark() << endl;
				}			
				  
				  
            }else if((MW_ptr->MW_detect_edge(Middleware_ID->Mark()))&&(Operation_Executed_Server_1->Mark() == 1))
			{
				   /* If this is a succesfully completed transaction edge */
				   /* Update the respective Client with the result from both servers */
					 ClientObjects[Middleware_ID->Mark()-1]->set_Oper_Exec_Status(MW_ptr->MW_get_operation_result(Middleware_ID->Mark(),2));
					 Operation_Executed_Server_1->Mark() = 0;
					 Operation_Executed_Server_2->Mark() = 0;
					 Operation_Executed_current->Mark() = 1;
					 Request_Operation_Server_current->Mark() = Request_Operation_Server_2->Mark();
					 Execute_Transaction_current->Mark() = Execute_Transaction_2->Mark();

					 if(GV_debug_flag==25)
					 {
						 cerr << "IG_Results_MultipleServers : An EDGE result has been returned for Client " << Middleware_ID->Mark() << " at time " << BaseModelClass::LastActionTime <<  endl;
						 cerr << "IG_Results_MultipleServers : The result returned for Client " << Middleware_ID->Mark() << " from Server 1 is " << MW_ptr->MW_get_operation_result(Middleware_ID->Mark(),1) << endl;
						 cerr << "IG_Results_MultipleServers : The result returned for Client " << Middleware_ID->Mark() << " from Server 2 is " << MW_ptr->MW_get_operation_result(Middleware_ID->Mark(),2) << endl;
					 }

				   /* In addition, if the current operation perfomed is a "Commit" or "Abort", then perform house-keeping */
				   if(MW_ptr->MW_detect_Transaction_complete(Middleware_ID->Mark(), 2)/* Check for succesful transaction Termination */)
				   {
				   
						if(GV_debug_flag==26)
						{
							cerr << "IG_Results_MultipleServers : The result returned for Client " << Middleware_ID->Mark() << " from Server 1 is " << MW_ptr->MW_get_operation_result(Middleware_ID->Mark(),1) << endl;
							cerr << "IG_Results_MultipleServers : The result returned for Client " << Middleware_ID->Mark() << " from Server 2 is " << MW_ptr->MW_get_operation_result(Middleware_ID->Mark(),2) << endl;
						}				   
						
					   Buffer_1_progress->Mark()=0;
					   Buffer_2_progress->Mark()=0;
					   MW_ptr->MW_results_reset(Middleware_ID->Mark());
					   MW_ptr->MW_buffer_reset(Middleware_ID->Mark());
				       Request_Operation_Server_1->Mark()=0;
					   Execute_Transaction_1->Mark()=0;
					   Request_Operation_Server_2->Mark()=0;
					   Execute_Transaction_2->Mark()=0;					 					   
				   }else
				   {
					   /* Update the Transaction progress for this server */
					   MW_ptr->MW_update_Trans_progress(Middleware_ID->Mark(), 1);
					   MW_ptr->MW_update_Trans_progress(Middleware_ID->Mark(), 2);
				   }


				/* Reset flag preventing "Edge detection" from firing more than once */
				Oper_Edge_detection_called->Mark()=0;				
			}else if((MW_ptr->MW_detect_edge(Middleware_ID->Mark()))&&(Operation_Executed_Server_1->Mark() == 0)&&(Wait_for_slower_server->Mark() == 1))
			{
				/* Reset the flag indicating that the faster server has already returned */
				Wait_for_slower_server->Mark() = 0;

				   /* If this is a succesfully completed transaction edge */
				   /* Update the respective Client with the result from both servers */
					 ClientObjects[Middleware_ID->Mark()-1]->set_Oper_Exec_Status(MW_ptr->MW_get_operation_result(Middleware_ID->Mark(),2));
					 Operation_Executed_Server_1->Mark() = 0;
					 Operation_Executed_Server_2->Mark() = 0;
					 Operation_Executed_current->Mark() = 1;
					 Request_Operation_Server_current->Mark() = Request_Operation_Server_2->Mark();
					 Execute_Transaction_current->Mark() = Execute_Transaction_2->Mark();

					 if(GV_debug_flag==25)
					 {
						 cerr << "IG_Results_MultipleServers : An EDGE result has been returned for Client " << Middleware_ID->Mark() << " at time " << BaseModelClass::LastActionTime <<  endl;
						 cerr << "IG_Results_MultipleServers : The result returned for Client " << Middleware_ID->Mark() << " from Server 1 is " << MW_ptr->MW_get_operation_result(Middleware_ID->Mark(),1) << endl;
						 cerr << "IG_Results_MultipleServers : The result returned for Client " << Middleware_ID->Mark() << " from Server 2 is " << MW_ptr->MW_get_operation_result(Middleware_ID->Mark(),2) << endl;
					 }

				   /* In addition, if the current operation perfomed is a "Commit" or "Abort", then perform house-keeping */
				   if(MW_ptr->MW_detect_Transaction_complete(Middleware_ID->Mark(), 2)/* Check for succesful transaction Termination */)
				   {
				   
						if(GV_debug_flag==26)
						{
							cerr << "IG_Results_MultipleServers : The result returned for Client " << Middleware_ID->Mark() << " from Server 1 is " << MW_ptr->MW_get_operation_result(Middleware_ID->Mark(),1) << endl;
							cerr << "IG_Results_MultipleServers : The result returned for Client " << Middleware_ID->Mark() << " from Server 2 is " << MW_ptr->MW_get_operation_result(Middleware_ID->Mark(),2) << endl;
						}				   				   
					   Buffer_1_progress->Mark()=0;
					   Buffer_2_progress->Mark()=0;
					   MW_ptr->MW_results_reset(Middleware_ID->Mark());
					   MW_ptr->MW_buffer_reset(Middleware_ID->Mark());
				       Request_Operation_Server_1->Mark()=0;
					   Execute_Transaction_1->Mark()=0;
					   Request_Operation_Server_2->Mark()=0;
					   Execute_Transaction_2->Mark()=0;					 
					   
				   }else
				   {
					   /* Update the Transaction progress for this server */
					   MW_ptr->MW_update_Trans_progress(Middleware_ID->Mark(), 1);
					   MW_ptr->MW_update_Trans_progress(Middleware_ID->Mark(), 2);
				   }


				/* Reset flag preventing "Edge detection" from firing more than once */
				Oper_Edge_detection_called->Mark()=0;								
				
			}else if((MW_ptr->MW_detect_edge(Middleware_ID->Mark()))&&(Operation_Executed_Server_1->Mark() == 0)&&(Wait_for_slower_server->Mark() == 0))
			{
				/* Set the flag indicating that the slower server should be waited for  */
				Wait_for_slower_server->Mark() = 1;
				
				/* Set the Operation executed flag to zero, to prevent this gate from firing more than once */
				Operation_Executed_Server_2->Mark() = 0;
				
			}else
			{
				/* If other server is ready and an exception from the other server was not thrown */
				if((Operation_Executed_Server_1->Mark() == 1)&&(!(MW_ptr->MW_detect_exception(Middleware_ID->Mark(),1))))
				{
				
					if(GV_debug_flag==25)
					{
						cerr << "IG_Results_MultipleServers : Server 1 and 2's results for Client " << Middleware_ID->Mark() << " are being processed" << endl;
					}				
					
					/* send results to Client and wait for next operation */
					/* Update the respective Client's shared memory space with Server 1's result */
					ClientObjects[Middleware_ID->Mark()-1]->set_Oper_Exec_Status(MW_ptr->MW_get_operation_result(Middleware_ID->Mark(),2));
					
					/* Update the Transaction progress for the servers */
					MW_ptr->MW_update_Trans_progress(Middleware_ID->Mark(), 1);					
					MW_ptr->MW_update_Trans_progress(Middleware_ID->Mark(), 2);
					
					Operation_Executed_Server_1->Mark() = 0;
					Operation_Executed_Server_2->Mark() = 0;					
					Operation_Executed_current->Mark() = 1;
					Request_Operation_Server_current->Mark() = Request_Operation_Server_2->Mark();
					Execute_Transaction_current->Mark() = Execute_Transaction_2->Mark();

					/* Reset flag preventing "Edge detection" from firing more than once */
					Oper_Edge_detection_called->Mark()=0;				
				}else if((Operation_Executed_Server_1->Mark() == 1)&&(MW_ptr->MW_detect_exception(Middleware_ID->Mark(),1)))
				{
					/* If one of the servers has thrown an exception */
					/* Signal an Exception has occurred; intercept the result of the faster Server */
					Exception->Mark() = 1;

					if(GV_debug_flag==26)
					{
					   cerr << "IG_Results_MultipleServers : d) Server 1 has returned an exception for Client " << Middleware_ID->Mark() << endl;
					}			

					
				}else if(Operation_Executed_Server_1->Mark() == 0)
				{
					 if(GV_debug_flag==25)
					 {
						cerr << "IG_Results_MultipleServers : Server 1's result for Client " << Middleware_ID->Mark() << " is being processed before Server 2?" << endl;
					 }				
				
					/* send results to Client and wait for next operation */
					/* Update the respective Client's shared memory space with Server 1's result */
					ClientObjects[Middleware_ID->Mark()-1]->set_Oper_Exec_Status(MW_ptr->MW_get_operation_result(Middleware_ID->Mark(),2));
					
					/* Update the Transaction progress for the servers */
					MW_ptr->MW_update_Trans_progress(Middleware_ID->Mark(), 2);
					
					Operation_Executed_Server_2->Mark() = 0;					
					Operation_Executed_current->Mark() = 1;
					Request_Operation_Server_current->Mark() = Request_Operation_Server_2->Mark();
					Execute_Transaction_current->Mark() = Execute_Transaction_2->Mark();

					/* Reset flag preventing "Edge detection" from firing more than once */
					Oper_Edge_detection_called->Mark()=0;									
				}
			}
		 }
    }
}

/* Send signal to respective Client */

  return this;
}

/*======================TA_Oper_Edge_detectionActivity========================*/

Middleware_SANSAN::TA_Oper_Edge_detectionActivity::TA_Oper_Edge_detectionActivity(){
  TheDistributionParameters = new double[1];
  ActivityInitialize("TA_Oper_Edge_detection",1,Deterministic, RaceEnabled, 11,9, false);
}

Middleware_SANSAN::TA_Oper_Edge_detectionActivity::~TA_Oper_Edge_detectionActivity(){
  delete[] TheDistributionParameters;
}

void Middleware_SANSAN::TA_Oper_Edge_detectionActivity::LinkVariables(){
  Server_1_enabled->Register(&Server_1_enabled_Mobius_Mark);
  Begin_called_1->Register(&Begin_called_1_Mobius_Mark);
  Request_Operation_Server_current->Register(&Request_Operation_Server_current_Mobius_Mark);
  Execute_Transaction_current->Register(&Execute_Transaction_current_Mobius_Mark);
  Server_2_enabled->Register(&Server_2_enabled_Mobius_Mark);
  Begin_called_2->Register(&Begin_called_2_Mobius_Mark);
  Oper_Edge_detection_called->Register(&Oper_Edge_detection_called_Mobius_Mark);
  Exception->Register(&Exception_Mobius_Mark);
  Operation_Executed_current->Register(&Operation_Executed_current_Mobius_Mark);
  Middleware_ID->Register(&Middleware_ID_Mobius_Mark);
  Mutex_pool->Register(&Mutex_pool_Mobius_Mark);
  Mutex_requested->Register(&Mutex_requested_Mobius_Mark);
  Mutex_granted->Register(&Mutex_granted_Mobius_Mark);
  Buffer_Operations->Register(&Buffer_Operations_Mobius_Mark);
  Signal_Server->Register(&Signal_Server_Mobius_Mark);
}

bool Middleware_SANSAN::TA_Oper_Edge_detectionActivity::Enabled(){
  OldEnabled=NewEnabled;
  NewEnabled=((((((Server_1_enabled->Mark()==1)&&(Begin_called_1->Mark()==0)&&(Request_Operation_Server_current->Mark()==0)&&(Execute_Transaction_current->Mark()==1))
||((Server_1_enabled->Mark()==1)&&(Begin_called_1->Mark()==1)&&(Request_Operation_Server_current->Mark()==1)&&(Execute_Transaction_current->Mark()==1)))
||(((Server_2_enabled->Mark()==1)&&(Begin_called_2->Mark()==0)&&(Request_Operation_Server_current->Mark()==0)&&(Execute_Transaction_current->Mark()==1))
||((Server_2_enabled->Mark()==1)&&(Begin_called_2->Mark()==1)&&(Request_Operation_Server_current->Mark()==1)&&(Execute_Transaction_current->Mark()==1))))&&(Oper_Edge_detection_called->Mark()==0)&&(Exception->Mark()==0)&&(Operation_Executed_current->Mark()==0)));
  return NewEnabled;
}

double Middleware_SANSAN::TA_Oper_Edge_detectionActivity::DeterministicParamValue(){
  return 1e-23;
  return 1.0;  // default rate if none is specified
}

double Middleware_SANSAN::TA_Oper_Edge_detectionActivity::Weight(){ 
  return 1;
}

bool Middleware_SANSAN::TA_Oper_Edge_detectionActivity::ReactivationPredicate(){ 
  return false;
}

bool Middleware_SANSAN::TA_Oper_Edge_detectionActivity::ReactivationFunction(){ 
  return false;
}

double Middleware_SANSAN::TA_Oper_Edge_detectionActivity::SampleDistribution(){
  return 1e-23;
}

double* Middleware_SANSAN::TA_Oper_Edge_detectionActivity::ReturnDistributionParameters(){
  TheDistributionParameters[0] = DeterministicParamValue();
  return TheDistributionParameters;
}

int Middleware_SANSAN::TA_Oper_Edge_detectionActivity::Rank(){
  return 1;
}

BaseActionClass* Middleware_SANSAN::TA_Oper_Edge_detectionActivity::Fire(){
  Oper_Edge_detection_called->Mark() = 1;

if(GV_debug_flag==26)
{
//   std::cerr << "Middleware::IG_Oper_Edge_detection: The value of predicate 1 is " << ((Server_1_enabled->Mark()==1)&&(Begin_called_1->Mark()==0)&&(Request_Operation_Server_current->Mark()==0)&&(Execute_Transaction_current->Mark()==1)) << " for Middleware " << Middleware_ID->Mark() << endl;
//   std::cerr << "Middleware::IG_Oper_Edge_detection: The value of predicate 2 is " << ((Server_1_enabled->Mark()==1)&&(Begin_called_1->Mark()==1)&&(Request_Operation_Server_current->Mark()==1)&&(Execute_Transaction_current->Mark()==1)) << " for Middleware " << Middleware_ID->Mark() << endl;
//   std::cerr << "Middleware::IG_Oper_Edge_detection: The value of predicate 3 is " << ((Server_2_enabled->Mark()==1)&&(Begin_called_2->Mark()==0)&&(Request_Operation_Server_current->Mark()==0)&&(Execute_Transaction_current->Mark()==1)) << " for Middleware " << Middleware_ID->Mark() << endl;
//   std::cerr << "Middleware::IG_Oper_Edge_detection: The value of predicate 4 is " << ((Server_2_enabled->Mark()==1)&&(Begin_called_2->Mark()==1)&&(Request_Operation_Server_current->Mark()==1)&&(Execute_Transaction_current->Mark()==1)) << " for Middleware " << Middleware_ID->Mark() << endl;



   std::cerr << "Middleware::IG_Oper_Edge_detection: The value of ClientObjects[Middleware_ID->Mark()-1]->get_Trans_Profile_oper_ID() is " << ClientObjects[Middleware_ID->Mark()-1]->get_Trans_Profile_oper_ID() << " for Middleware " << Middleware_ID->Mark() << endl;
   std::cerr << "Middleware::IG_Oper_Edge_detection: The value of ClientObjects[Middleware_ID->Mark()-1]->get_Shared_Data_Operation() is " << ClientObjects[Middleware_ID->Mark()-1]->get_Shared_Data_Operation() << " for Middleware " << Middleware_ID->Mark() << endl;
//   std::cerr << "Middleware::IG_Oper_Edge_detection: The value of ClientObjects[Middleware_ID->Mark()-1]->get_Shared_Data_Key() is " << ClientObjects[Middleware_ID->Mark()-1]->get_Shared_Data_Key() << " for Middleware " << Middleware_ID->Mark() << endl;
//   std::cerr << "Middleware::IG_Oper_Edge_detection: The value of Begin_called_1->Mark() is " << Begin_called_1->Mark() << " for Middleware " << Middleware_ID->Mark() << endl;
//   std::cerr << "Middleware::IG_Oper_Edge_detection: The value of Begin_called_2->Mark() is " << Begin_called_2->Mark() << " for Middleware " << Middleware_ID->Mark() << endl;
//   std::cerr << "Middleware::IG_Oper_Edge_detection: The value of Request_Operation_Server_current->Mark() is " << Request_Operation_Server_current->Mark() << " for Middleware " << Middleware_ID->Mark() << endl;
   std::cerr << "Middleware::IG_Oper_Edge_detection: The value of Execute_Transaction_current->Mark() is " << Execute_Transaction_current->Mark() << " for Middleware " << Middleware_ID->Mark() << endl;
}

/* Buffer the current operation request and associated data from the Client */
MW_ptr->MW_buffer_operation(Middleware_ID->Mark(), ClientObjects[Middleware_ID->Mark()-1]->get_Shared_Data_Operation(), ClientObjects[Middleware_ID->Mark()-1]->get_Shared_Data_Key(), ClientObjects[Middleware_ID->Mark()-1]->get_Trans_Profile_oper_ID());

/* If (an edge)&&(Server_1_enabled && Server_2_enabled), then access mutex logic */
if((MW_ptr->MW_detect_edge(Middleware_ID->Mark()))&&(Server_1_enabled->Mark()==1)&&(Server_2_enabled->Mark()==1))
{

    Mutex_pool->Mark() = Mutex_pool->Mark() + 1;
    Mutex_requested->Mark() = 1;

if((GV_debug_flag==26)&&((ClientObjects[Middleware_ID->Mark()-1]->get_Shared_Data_Operation()).compare(std::string("Abort"))==0))
{
   std::cerr << "The Middleware::IG_Oper_Edge_detection Mutex behaviour for Middleware " << Middleware_ID->Mark() << " is being enabled with IG_Mutex_pool predicate value "  << ((Mutex_pool->Mark()>0)&&(Mutex_requested->Mark()==1)&&(Mutex_granted->Mark()==0)&&(Server_1_enabled->Mark()==1)&&(Server_2_enabled->Mark()==1)&&(Exception->Mark()==0)&&((MW_ptr->MW_get_Trans_progress(Middleware_ID->Mark(), 1) == MW_ptr->MW_get_Trans_progress(Middleware_ID->Mark(), 2))||((ClientObjects[Middleware_ID->Mark()-1]->get_Shared_Data_Operation()).compare(std::string("Abort"))==0))) << endl;
}

if(GV_debug_flag==27)
{
   std::cerr << "The Middleware::IG_Oper_Edge_detection Mutex behaviour for Middleware " << Middleware_ID->Mark() << " is being enabled with IG_Mutex_pool predicate value "  << ((Mutex_pool->Mark()>0)&&(Mutex_requested->Mark()==1)&&(Mutex_granted->Mark()==0)&&(Server_1_enabled->Mark()==1)&&(Server_2_enabled->Mark()==1)&&(Exception->Mark()==0)&&((MW_ptr->MW_get_Trans_progress(Middleware_ID->Mark(), 1) == MW_ptr->MW_get_Trans_progress(Middleware_ID->Mark(), 2))||((ClientObjects[Middleware_ID->Mark()-1]->get_Shared_Data_Operation()).compare(std::string("Abort"))==0))) << endl;
   std::cerr << "Middleware::IG_Oper_Edge_detection : (Mutex_pool->Mark()>0) : " << (Mutex_pool->Mark()>0) << endl;
   std::cerr << "Middleware::IG_Oper_Edge_detection : (Mutex_requested->Mark()==1) : " << (Mutex_requested->Mark()==1) << endl;
   std::cerr << "Middleware::IG_Oper_Edge_detection : (Mutex_granted->Mark()==0) : " << (Mutex_granted->Mark()==0) << endl;
   std::cerr << "Middleware::IG_Oper_Edge_detection : (Server_1_enabled->Mark()==1) : " << (Server_1_enabled->Mark()==1) << endl;
   std::cerr << "Middleware::IG_Oper_Edge_detection : (Server_2_enabled->Mark()==1) : " << (Server_2_enabled->Mark()==1) << endl;
   std::cerr << "Middleware::IG_Oper_Edge_detection : (Exception->Mark()==0) : " << (Exception->Mark()==0) << endl;
   std::cerr << "Middleware::IG_Oper_Edge_detection : ((MW_ptr->MW_get_Trans_progress(Middleware_ID->Mark(), 1) == MW_ptr->MW_get_Trans_progress(Middleware_ID->Mark(), 2))||((ClientObjects[Middleware_ID->Mark()-1]->get_Shared_Data_Operation()).compare(std::string(\"Abort\"))==0)) : " << ((MW_ptr->MW_get_Trans_progress(Middleware_ID->Mark(), 1) == MW_ptr->MW_get_Trans_progress(Middleware_ID->Mark(), 2))||((ClientObjects[Middleware_ID->Mark()-1]->get_Shared_Data_Operation()).compare(std::string("Abort"))==0)) << endl;
   std::cerr << "Middleware::IG_Oper_Edge_detection : MW_ptr->MW_get_Trans_progress(Middleware_ID->Mark(), 1) : " << MW_ptr->MW_get_Trans_progress(Middleware_ID->Mark(), 1) << endl;
   std::cerr << "Middleware::IG_Oper_Edge_detection : MW_ptr->MW_get_Trans_progress(Middleware_ID->Mark(), 2) : " << MW_ptr->MW_get_Trans_progress(Middleware_ID->Mark(), 2) << endl;
}

}else if((!(MW_ptr->MW_detect_edge(Middleware_ID->Mark())))&&(Server_1_enabled->Mark()==1)&&(Server_2_enabled->Mark()==1))
{
    /* If not an edge but 2 servers are enabled, access logic that coordinates which Server
     * will perform the latest operation 
     */
    Buffer_Operations->Mark() = 1;

if(GV_debug_flag==23)
{
   cerr << "The Middleware::IG_Oper_Edge_detection : buffering will occur for Middleware " << Middleware_ID->Mark() << endl;
}

}else
{
    /* Otherwise, signal the active server to carry out the latest Client request */
    Signal_Server->Mark()=1;
}

if(GV_debug_flag==25)
{
   cerr << "The Middleware::IG_Oper_Edge_detection gate has fired for Middleware " << Middleware_ID->Mark() << " at time " << BaseModelClass::LastActionTime << endl;
}
  return this;
}

/*======================TA_Mutex_releaseActivity========================*/

Middleware_SANSAN::TA_Mutex_releaseActivity::TA_Mutex_releaseActivity(){
  TheDistributionParameters = new double[1];
  ActivityInitialize("TA_Mutex_release",2,Exponential, RaceEnabled, 7,6, false);
}

Middleware_SANSAN::TA_Mutex_releaseActivity::~TA_Mutex_releaseActivity(){
  delete[] TheDistributionParameters;
}

void Middleware_SANSAN::TA_Mutex_releaseActivity::LinkVariables(){
  Mutex_granted->Register(&Mutex_granted_Mobius_Mark);
  Middleware_ID->Register(&Middleware_ID_Mobius_Mark);
  Operation_Executed_Server_1->Register(&Operation_Executed_Server_1_Mobius_Mark);
  Operation_Executed_Server_2->Register(&Operation_Executed_Server_2_Mobius_Mark);
  Server_1_enabled->Register(&Server_1_enabled_Mobius_Mark);
  Server_2_enabled->Register(&Server_2_enabled_Mobius_Mark);
  Mutex_pool->Register(&Mutex_pool_Mobius_Mark);
  Mutex_requested->Register(&Mutex_requested_Mobius_Mark);
  Exception->Register(&Exception_Mobius_Mark);
}

bool Middleware_SANSAN::TA_Mutex_releaseActivity::Enabled(){
  OldEnabled=NewEnabled;
  NewEnabled=(((Mutex_granted->Mark()==Middleware_ID->Mark())&&(Operation_Executed_Server_1->Mark()==1)&&(Operation_Executed_Server_2->Mark()==1)&&(Server_1_enabled->Mark()==1)&&(Server_2_enabled->Mark()==1)));
  return NewEnabled;
}

double Middleware_SANSAN::TA_Mutex_releaseActivity::Rate(){
  return //exponential 37
//lognormal : mu = -3.9, sigma^2 = 0.9
//1e-23
37;
  return 1.0;  // default rate if none is specified
}

double Middleware_SANSAN::TA_Mutex_releaseActivity::Weight(){ 
  return 1;
}

bool Middleware_SANSAN::TA_Mutex_releaseActivity::ReactivationPredicate(){ 
  return false;
}

bool Middleware_SANSAN::TA_Mutex_releaseActivity::ReactivationFunction(){ 
  return false;
}

double Middleware_SANSAN::TA_Mutex_releaseActivity::SampleDistribution(){
  return TheDistribution->Exponential(Rate());
}

double* Middleware_SANSAN::TA_Mutex_releaseActivity::ReturnDistributionParameters(){
  TheDistributionParameters[0] = Rate();
  return TheDistributionParameters;
}

int Middleware_SANSAN::TA_Mutex_releaseActivity::Rank(){
  return 1;
}

BaseActionClass* Middleware_SANSAN::TA_Mutex_releaseActivity::Fire(){
  /* Release the Mutex for the other Middleware threads */
Mutex_granted->Mark()=0;

if(GV_debug_flag==27)
{
   std::cerr << "IG_Mutex_release: The result returned by each server for Client " << Middleware_ID->Mark() << " is " << MW_ptr->MW_get_operation_result(Middleware_ID->Mark(), 1) << " and " << MW_ptr->MW_get_operation_result(Middleware_ID->Mark(), 2) << " at time " << BaseModelClass::LastActionTime <<  endl;
   std::cerr << "IG_Mutex_release: The progress of each server for Client " << Middleware_ID->Mark() << " is " << MW_ptr->MW_get_Trans_progress(Middleware_ID->Mark(), 1) << " and " << MW_ptr->MW_get_Trans_progress(Middleware_ID->Mark(), 2) << " at time " << BaseModelClass::LastActionTime <<  endl;
   std::cerr << "IG_Mutex_release: the boolean to activate the next Mutex grab has value " << ((Mutex_pool->Mark()>0)&&(Mutex_requested->Mark()==1)&&(Mutex_granted->Mark()==0)&&(Server_1_enabled->Mark()==1)&&(Server_2_enabled->Mark()==1)&&(Exception->Mark()==0)&&((MW_ptr->MW_get_Trans_progress(Middleware_ID->Mark(), 1) == MW_ptr->MW_get_Trans_progress(Middleware_ID->Mark(), 2))||((ClientObjects[Middleware_ID->Mark()-1]->get_Shared_Data_Operation()).compare(std::string("Abort"))==0))) << std::endl;
}

/* Control will now be passed to the IG_Results_MultipleServers gate*/
  return this;
}

