#ifndef _DURATIONS_OF_REQUESTS_AND_OPERATIONS_PVS_
#define _DURATIONS_OF_REQUESTS_AND_OPERATIONS_PVS_
#include "udf/DIDERO_PC.h"
#include <math.h>
#include "Cpp/Performance_Variables/PerformanceVariableNode.hpp"
#include "Composed/Client_Server/Client_ServerRJ__Rep_Client_DivSQL.h"
#include "Composed/Client_Server/Client_ServerRJ__Client_DivSQL.h"
#include "Composed/Client_Server/Client_ServerRJ.h"
#include "Cpp/Performance_Variables/IntervalOfTime.hpp"
#include "Cpp/Performance_Variables/IntervalOfTimeImpulse.hpp"



class Durations_of_Requests_and_OperationsPV0Impulse0:public IntervalOfTimeImpulse
{
 public:
  ClientSANSAN *ClientSAN;

  Durations_of_Requests_and_OperationsPV0Impulse0();
  ~Durations_of_Requests_and_OperationsPV0Impulse0();
  double Impulse_Function(double);
  ImpulseNodeClass** CreateImpulseWorkerList(int);
 private:
  ImpulseNodeClass** ImpulseWorkerList;
  int ImpulseWorkerListLength;
};

class Durations_of_Requests_and_OperationsPV0:public PerformanceVariableNode
{
 public:
  Client_ServerRJ *TheClient_ServerRJ;

  Durations_of_Requests_and_OperationsPV0Impulse0 Impulse0;

  Durations_of_Requests_and_OperationsPV0(int timeindex=0);
  ~Durations_of_Requests_and_OperationsPV0();
  void CreateWorkerList(void);
};


class Durations_of_Requests_and_OperationsPV1Impulse0:public IntervalOfTimeImpulse
{
 public:
  TransactionSAN_2SAN *TransactionSAN_2;

  Durations_of_Requests_and_OperationsPV1Impulse0();
  ~Durations_of_Requests_and_OperationsPV1Impulse0();
  double Impulse_Function(double);
  ImpulseNodeClass** CreateImpulseWorkerList(int);
 private:
  ImpulseNodeClass** ImpulseWorkerList;
  int ImpulseWorkerListLength;
};

class Durations_of_Requests_and_OperationsPV1:public PerformanceVariableNode
{
 public:
  Client_ServerRJ *TheClient_ServerRJ;

  Durations_of_Requests_and_OperationsPV1Impulse0 Impulse0;

  Durations_of_Requests_and_OperationsPV1(int timeindex=0);
  ~Durations_of_Requests_and_OperationsPV1();
  void CreateWorkerList(void);
};


class Durations_of_Requests_and_OperationsPV2Impulse0:public IntervalOfTimeImpulse
{
 public:
  TransactionSAN_1SAN *TransactionSAN_1;

  Durations_of_Requests_and_OperationsPV2Impulse0();
  ~Durations_of_Requests_and_OperationsPV2Impulse0();
  double Impulse_Function(double);
  ImpulseNodeClass** CreateImpulseWorkerList(int);
 private:
  ImpulseNodeClass** ImpulseWorkerList;
  int ImpulseWorkerListLength;
};

class Durations_of_Requests_and_OperationsPV2:public PerformanceVariableNode
{
 public:
  Client_ServerRJ *TheClient_ServerRJ;

  Durations_of_Requests_and_OperationsPV2Impulse0 Impulse0;

  Durations_of_Requests_and_OperationsPV2(int timeindex=0);
  ~Durations_of_Requests_and_OperationsPV2();
  void CreateWorkerList(void);
};

#endif
