
#include "Study/DIDERO_PC_Default/DIDERO_PC_DefaultRangeStudy.h"

//******************************************************
//Global Variables
//******************************************************
double Choose_Cust_using_ID;
bool GV_Couple_Server_Trans_Durations;
int GV_Cust_per_District;
bool GV_DefaultResidualTimes;
int GV_Efficient_Oper_Capacity_Server_1;
int GV_Efficient_Oper_Capacity_Server_2;
short GV_Enable_Client_View_Trace;
short GV_Enable_Server_1_View_Trace;
short GV_Enable_Server_2_View_Trace;
double GV_ExpScaling_LowerBound;
int GV_Experiment_Runs;
bool GV_IntraTransDepBurstiness;
bool GV_IntraTransaction_Dependence;
short GV_Num_Dist_per_Warehouses;
short GV_Number_of_Clients_and_Trans;
short GV_Number_of_Warehouses;
float GV_Oper_Dur_Raw_Data_Scaling;
double GV_ReacModel_ExpScaling;
double GV_ReacModel_PolyPower;
double GV_Server_1_Prob_of_IntraTransDependence;
bool GV_Server_1_enabled;
double GV_Server_2_Prob_of_IntraTransDependence;
bool GV_Server_2_enabled;
bool GV_Step_Inverse_Transform;
bool GV_TPCC;
short GV_debug_flag;
double Prob_of_Bad_Cust;
double Prob_of_Cust_ID;
double Prob_of_Delivery;
double Prob_of_Local_Orderlines;
double Prob_of_NewOrder;
double Prob_of_Orderstatus;
double Prob_of_Payment;
double Prob_of_Stocklevel;

//********************************************************
//DIDERO_PC_DefaultRangeStudy Constructor
//********************************************************
DIDERO_PC_DefaultRangeStudy::DIDERO_PC_DefaultRangeStudy() {

  // define arrays of global variable names and types
  NumGVs = 34;
  NumExps = 1;

  GVNames = new char*[NumGVs];
  GVTypes = new char*[NumGVs];
  GVNames[0]=strdup("Choose_Cust_using_ID");
  GVTypes[0]=strdup("double");
  GVNames[1]=strdup("GV_Couple_Server_Trans_Durations");
  GVTypes[1]=strdup("bool");
  GVNames[2]=strdup("GV_Cust_per_District");
  GVTypes[2]=strdup("int");
  GVNames[3]=strdup("GV_DefaultResidualTimes");
  GVTypes[3]=strdup("bool");
  GVNames[4]=strdup("GV_Efficient_Oper_Capacity_Server_1");
  GVTypes[4]=strdup("int");
  GVNames[5]=strdup("GV_Efficient_Oper_Capacity_Server_2");
  GVTypes[5]=strdup("int");
  GVNames[6]=strdup("GV_Enable_Client_View_Trace");
  GVTypes[6]=strdup("short");
  GVNames[7]=strdup("GV_Enable_Server_1_View_Trace");
  GVTypes[7]=strdup("short");
  GVNames[8]=strdup("GV_Enable_Server_2_View_Trace");
  GVTypes[8]=strdup("short");
  GVNames[9]=strdup("GV_ExpScaling_LowerBound");
  GVTypes[9]=strdup("double");
  GVNames[10]=strdup("GV_Experiment_Runs");
  GVTypes[10]=strdup("int");
  GVNames[11]=strdup("GV_IntraTransDepBurstiness");
  GVTypes[11]=strdup("bool");
  GVNames[12]=strdup("GV_IntraTransaction_Dependence");
  GVTypes[12]=strdup("bool");
  GVNames[13]=strdup("GV_Num_Dist_per_Warehouses");
  GVTypes[13]=strdup("short");
  GVNames[14]=strdup("GV_Number_of_Clients_and_Trans");
  GVTypes[14]=strdup("short");
  GVNames[15]=strdup("GV_Number_of_Warehouses");
  GVTypes[15]=strdup("short");
  GVNames[16]=strdup("GV_Oper_Dur_Raw_Data_Scaling");
  GVTypes[16]=strdup("float");
  GVNames[17]=strdup("GV_ReacModel_ExpScaling");
  GVTypes[17]=strdup("double");
  GVNames[18]=strdup("GV_ReacModel_PolyPower");
  GVTypes[18]=strdup("double");
  GVNames[19]=strdup("GV_Server_1_Prob_of_IntraTransDependence");
  GVTypes[19]=strdup("double");
  GVNames[20]=strdup("GV_Server_1_enabled");
  GVTypes[20]=strdup("bool");
  GVNames[21]=strdup("GV_Server_2_Prob_of_IntraTransDependence");
  GVTypes[21]=strdup("double");
  GVNames[22]=strdup("GV_Server_2_enabled");
  GVTypes[22]=strdup("bool");
  GVNames[23]=strdup("GV_Step_Inverse_Transform");
  GVTypes[23]=strdup("bool");
  GVNames[24]=strdup("GV_TPCC");
  GVTypes[24]=strdup("bool");
  GVNames[25]=strdup("GV_debug_flag");
  GVTypes[25]=strdup("short");
  GVNames[26]=strdup("Prob_of_Bad_Cust");
  GVTypes[26]=strdup("double");
  GVNames[27]=strdup("Prob_of_Cust_ID");
  GVTypes[27]=strdup("double");
  GVNames[28]=strdup("Prob_of_Delivery");
  GVTypes[28]=strdup("double");
  GVNames[29]=strdup("Prob_of_Local_Orderlines");
  GVTypes[29]=strdup("double");
  GVNames[30]=strdup("Prob_of_NewOrder");
  GVTypes[30]=strdup("double");
  GVNames[31]=strdup("Prob_of_Orderstatus");
  GVTypes[31]=strdup("double");
  GVNames[32]=strdup("Prob_of_Payment");
  GVTypes[32]=strdup("double");
  GVNames[33]=strdup("Prob_of_Stocklevel");
  GVTypes[33]=strdup("double");

  // create the arrays to store the values of each gv
  Choose_Cust_using_IDValues = new double[NumExps];
  GV_Couple_Server_Trans_DurationsValues = new bool[NumExps];
  GV_Cust_per_DistrictValues = new int[NumExps];
  GV_DefaultResidualTimesValues = new bool[NumExps];
  GV_Efficient_Oper_Capacity_Server_1Values = new int[NumExps];
  GV_Efficient_Oper_Capacity_Server_2Values = new int[NumExps];
  GV_Enable_Client_View_TraceValues = new short[NumExps];
  GV_Enable_Server_1_View_TraceValues = new short[NumExps];
  GV_Enable_Server_2_View_TraceValues = new short[NumExps];
  GV_ExpScaling_LowerBoundValues = new double[NumExps];
  GV_Experiment_RunsValues = new int[NumExps];
  GV_IntraTransDepBurstinessValues = new bool[NumExps];
  GV_IntraTransaction_DependenceValues = new bool[NumExps];
  GV_Num_Dist_per_WarehousesValues = new short[NumExps];
  GV_Number_of_Clients_and_TransValues = new short[NumExps];
  GV_Number_of_WarehousesValues = new short[NumExps];
  GV_Oper_Dur_Raw_Data_ScalingValues = new float[NumExps];
  GV_ReacModel_ExpScalingValues = new double[NumExps];
  GV_ReacModel_PolyPowerValues = new double[NumExps];
  GV_Server_1_Prob_of_IntraTransDependenceValues = new double[NumExps];
  GV_Server_1_enabledValues = new bool[NumExps];
  GV_Server_2_Prob_of_IntraTransDependenceValues = new double[NumExps];
  GV_Server_2_enabledValues = new bool[NumExps];
  GV_Step_Inverse_TransformValues = new bool[NumExps];
  GV_TPCCValues = new bool[NumExps];
  GV_debug_flagValues = new short[NumExps];
  Prob_of_Bad_CustValues = new double[NumExps];
  Prob_of_Cust_IDValues = new double[NumExps];
  Prob_of_DeliveryValues = new double[NumExps];
  Prob_of_Local_OrderlinesValues = new double[NumExps];
  Prob_of_NewOrderValues = new double[NumExps];
  Prob_of_OrderstatusValues = new double[NumExps];
  Prob_of_PaymentValues = new double[NumExps];
  Prob_of_StocklevelValues = new double[NumExps];

  // call methods to assign values to each gv
  SetValues_Choose_Cust_using_ID();
  SetValues_GV_Couple_Server_Trans_Durations();
  SetValues_GV_Cust_per_District();
  SetValues_GV_DefaultResidualTimes();
  SetValues_GV_Efficient_Oper_Capacity_Server_1();
  SetValues_GV_Efficient_Oper_Capacity_Server_2();
  SetValues_GV_Enable_Client_View_Trace();
  SetValues_GV_Enable_Server_1_View_Trace();
  SetValues_GV_Enable_Server_2_View_Trace();
  SetValues_GV_ExpScaling_LowerBound();
  SetValues_GV_Experiment_Runs();
  SetValues_GV_IntraTransDepBurstiness();
  SetValues_GV_IntraTransaction_Dependence();
  SetValues_GV_Num_Dist_per_Warehouses();
  SetValues_GV_Number_of_Clients_and_Trans();
  SetValues_GV_Number_of_Warehouses();
  SetValues_GV_Oper_Dur_Raw_Data_Scaling();
  SetValues_GV_ReacModel_ExpScaling();
  SetValues_GV_ReacModel_PolyPower();
  SetValues_GV_Server_1_Prob_of_IntraTransDependence();
  SetValues_GV_Server_1_enabled();
  SetValues_GV_Server_2_Prob_of_IntraTransDependence();
  SetValues_GV_Server_2_enabled();
  SetValues_GV_Step_Inverse_Transform();
  SetValues_GV_TPCC();
  SetValues_GV_debug_flag();
  SetValues_Prob_of_Bad_Cust();
  SetValues_Prob_of_Cust_ID();
  SetValues_Prob_of_Delivery();
  SetValues_Prob_of_Local_Orderlines();
  SetValues_Prob_of_NewOrder();
  SetValues_Prob_of_Orderstatus();
  SetValues_Prob_of_Payment();
  SetValues_Prob_of_Stocklevel();
  SetDefaultMobiusRoot(MOBIUSROOT);
}


//******************************************************
//DIDERO_PC_DefaultRangeStudy Destructor
//******************************************************
DIDERO_PC_DefaultRangeStudy::~DIDERO_PC_DefaultRangeStudy() {
  delete [] Choose_Cust_using_IDValues;
  delete [] GV_Couple_Server_Trans_DurationsValues;
  delete [] GV_Cust_per_DistrictValues;
  delete [] GV_DefaultResidualTimesValues;
  delete [] GV_Efficient_Oper_Capacity_Server_1Values;
  delete [] GV_Efficient_Oper_Capacity_Server_2Values;
  delete [] GV_Enable_Client_View_TraceValues;
  delete [] GV_Enable_Server_1_View_TraceValues;
  delete [] GV_Enable_Server_2_View_TraceValues;
  delete [] GV_ExpScaling_LowerBoundValues;
  delete [] GV_Experiment_RunsValues;
  delete [] GV_IntraTransDepBurstinessValues;
  delete [] GV_IntraTransaction_DependenceValues;
  delete [] GV_Num_Dist_per_WarehousesValues;
  delete [] GV_Number_of_Clients_and_TransValues;
  delete [] GV_Number_of_WarehousesValues;
  delete [] GV_Oper_Dur_Raw_Data_ScalingValues;
  delete [] GV_ReacModel_ExpScalingValues;
  delete [] GV_ReacModel_PolyPowerValues;
  delete [] GV_Server_1_Prob_of_IntraTransDependenceValues;
  delete [] GV_Server_1_enabledValues;
  delete [] GV_Server_2_Prob_of_IntraTransDependenceValues;
  delete [] GV_Server_2_enabledValues;
  delete [] GV_Step_Inverse_TransformValues;
  delete [] GV_TPCCValues;
  delete [] GV_debug_flagValues;
  delete [] Prob_of_Bad_CustValues;
  delete [] Prob_of_Cust_IDValues;
  delete [] Prob_of_DeliveryValues;
  delete [] Prob_of_Local_OrderlinesValues;
  delete [] Prob_of_NewOrderValues;
  delete [] Prob_of_OrderstatusValues;
  delete [] Prob_of_PaymentValues;
  delete [] Prob_of_StocklevelValues;
  delete ThePVModel;
}


//******************************************************
// set values for Choose_Cust_using_ID
//******************************************************
void DIDERO_PC_DefaultRangeStudy::SetValues_Choose_Cust_using_ID() {
  Choose_Cust_using_IDValues[0] = 40.0;
}


//******************************************************
// set values for GV_Couple_Server_Trans_Durations
//******************************************************
void DIDERO_PC_DefaultRangeStudy::SetValues_GV_Couple_Server_Trans_Durations() {
  GV_Couple_Server_Trans_DurationsValues[0] = 0;
}


//******************************************************
// set values for GV_Cust_per_District
//******************************************************
void DIDERO_PC_DefaultRangeStudy::SetValues_GV_Cust_per_District() {
  GV_Cust_per_DistrictValues[0] = 3000;
}


//******************************************************
// set values for GV_DefaultResidualTimes
//******************************************************
void DIDERO_PC_DefaultRangeStudy::SetValues_GV_DefaultResidualTimes() {
  GV_DefaultResidualTimesValues[0] = 1;
}


//******************************************************
// set values for GV_Efficient_Oper_Capacity_Server_1
//******************************************************
void DIDERO_PC_DefaultRangeStudy::SetValues_GV_Efficient_Oper_Capacity_Server_1() {
  GV_Efficient_Oper_Capacity_Server_1Values[0] = 2;
}


//******************************************************
// set values for GV_Efficient_Oper_Capacity_Server_2
//******************************************************
void DIDERO_PC_DefaultRangeStudy::SetValues_GV_Efficient_Oper_Capacity_Server_2() {
  GV_Efficient_Oper_Capacity_Server_2Values[0] = 2;
}


//******************************************************
// set values for GV_Enable_Client_View_Trace
//******************************************************
void DIDERO_PC_DefaultRangeStudy::SetValues_GV_Enable_Client_View_Trace() {
  GV_Enable_Client_View_TraceValues[0] = 1;
}


//******************************************************
// set values for GV_Enable_Server_1_View_Trace
//******************************************************
void DIDERO_PC_DefaultRangeStudy::SetValues_GV_Enable_Server_1_View_Trace() {
  GV_Enable_Server_1_View_TraceValues[0] = 0;
}


//******************************************************
// set values for GV_Enable_Server_2_View_Trace
//******************************************************
void DIDERO_PC_DefaultRangeStudy::SetValues_GV_Enable_Server_2_View_Trace() {
  GV_Enable_Server_2_View_TraceValues[0] = 0;
}


//******************************************************
// set values for GV_ExpScaling_LowerBound
//******************************************************
void DIDERO_PC_DefaultRangeStudy::SetValues_GV_ExpScaling_LowerBound() {
  GV_ExpScaling_LowerBoundValues[0] = -1.0;
}


//******************************************************
// set values for GV_Experiment_Runs
//******************************************************
void DIDERO_PC_DefaultRangeStudy::SetValues_GV_Experiment_Runs() {
  GV_Experiment_RunsValues[0] = 1000;
}


//******************************************************
// set values for GV_IntraTransDepBurstiness
//******************************************************
void DIDERO_PC_DefaultRangeStudy::SetValues_GV_IntraTransDepBurstiness() {
  GV_IntraTransDepBurstinessValues[0] = 0;
}


//******************************************************
// set values for GV_IntraTransaction_Dependence
//******************************************************
void DIDERO_PC_DefaultRangeStudy::SetValues_GV_IntraTransaction_Dependence() {
  GV_IntraTransaction_DependenceValues[0] = 1;
}


//******************************************************
// set values for GV_Num_Dist_per_Warehouses
//******************************************************
void DIDERO_PC_DefaultRangeStudy::SetValues_GV_Num_Dist_per_Warehouses() {
  GV_Num_Dist_per_WarehousesValues[0] = 10;
}


//******************************************************
// set values for GV_Number_of_Clients_and_Trans
//******************************************************
void DIDERO_PC_DefaultRangeStudy::SetValues_GV_Number_of_Clients_and_Trans() {
  GV_Number_of_Clients_and_TransValues[0] = 5;
}


//******************************************************
// set values for GV_Number_of_Warehouses
//******************************************************
void DIDERO_PC_DefaultRangeStudy::SetValues_GV_Number_of_Warehouses() {
  GV_Number_of_WarehousesValues[0] = 10;
}


//******************************************************
// set values for GV_Oper_Dur_Raw_Data_Scaling
//******************************************************
void DIDERO_PC_DefaultRangeStudy::SetValues_GV_Oper_Dur_Raw_Data_Scaling() {
  GV_Oper_Dur_Raw_Data_ScalingValues[0] = 1.0E-9;
}


//******************************************************
// set values for GV_ReacModel_ExpScaling
//******************************************************
void DIDERO_PC_DefaultRangeStudy::SetValues_GV_ReacModel_ExpScaling() {
  GV_ReacModel_ExpScalingValues[0] = 0.0;
}


//******************************************************
// set values for GV_ReacModel_PolyPower
//******************************************************
void DIDERO_PC_DefaultRangeStudy::SetValues_GV_ReacModel_PolyPower() {
  GV_ReacModel_PolyPowerValues[0] = -0.05;
}


//******************************************************
// set values for GV_Server_1_Prob_of_IntraTransDependence
//******************************************************
void DIDERO_PC_DefaultRangeStudy::SetValues_GV_Server_1_Prob_of_IntraTransDependence() {
  GV_Server_1_Prob_of_IntraTransDependenceValues[0] = 100.0;
}


//******************************************************
// set values for GV_Server_1_enabled
//******************************************************
void DIDERO_PC_DefaultRangeStudy::SetValues_GV_Server_1_enabled() {
  GV_Server_1_enabledValues[0] = 1;
}


//******************************************************
// set values for GV_Server_2_Prob_of_IntraTransDependence
//******************************************************
void DIDERO_PC_DefaultRangeStudy::SetValues_GV_Server_2_Prob_of_IntraTransDependence() {
  GV_Server_2_Prob_of_IntraTransDependenceValues[0] = 0.8;
}


//******************************************************
// set values for GV_Server_2_enabled
//******************************************************
void DIDERO_PC_DefaultRangeStudy::SetValues_GV_Server_2_enabled() {
  GV_Server_2_enabledValues[0] = 1;
}


//******************************************************
// set values for GV_Step_Inverse_Transform
//******************************************************
void DIDERO_PC_DefaultRangeStudy::SetValues_GV_Step_Inverse_Transform() {
  GV_Step_Inverse_TransformValues[0] = 0;
}


//******************************************************
// set values for GV_TPCC
//******************************************************
void DIDERO_PC_DefaultRangeStudy::SetValues_GV_TPCC() {
  GV_TPCCValues[0] = 1;
}


//******************************************************
// set values for GV_debug_flag
//******************************************************
void DIDERO_PC_DefaultRangeStudy::SetValues_GV_debug_flag() {
  GV_debug_flagValues[0] = 28;
}


//******************************************************
// set values for Prob_of_Bad_Cust
//******************************************************
void DIDERO_PC_DefaultRangeStudy::SetValues_Prob_of_Bad_Cust() {
  Prob_of_Bad_CustValues[0] = 1.0;
}


//******************************************************
// set values for Prob_of_Cust_ID
//******************************************************
void DIDERO_PC_DefaultRangeStudy::SetValues_Prob_of_Cust_ID() {
  Prob_of_Cust_IDValues[0] = 40.0;
}


//******************************************************
// set values for Prob_of_Delivery
//******************************************************
void DIDERO_PC_DefaultRangeStudy::SetValues_Prob_of_Delivery() {
  Prob_of_DeliveryValues[0] = 4.2;
}


//******************************************************
// set values for Prob_of_Local_Orderlines
//******************************************************
void DIDERO_PC_DefaultRangeStudy::SetValues_Prob_of_Local_Orderlines() {
  Prob_of_Local_OrderlinesValues[0] = 90.0;
}


//******************************************************
// set values for Prob_of_NewOrder
//******************************************************
void DIDERO_PC_DefaultRangeStudy::SetValues_Prob_of_NewOrder() {
  Prob_of_NewOrderValues[0] = 44.5;
}


//******************************************************
// set values for Prob_of_Orderstatus
//******************************************************
void DIDERO_PC_DefaultRangeStudy::SetValues_Prob_of_Orderstatus() {
  Prob_of_OrderstatusValues[0] = 4.1;
}


//******************************************************
// set values for Prob_of_Payment
//******************************************************
void DIDERO_PC_DefaultRangeStudy::SetValues_Prob_of_Payment() {
  Prob_of_PaymentValues[0] = 43.1;
}


//******************************************************
// set values for Prob_of_Stocklevel
//******************************************************
void DIDERO_PC_DefaultRangeStudy::SetValues_Prob_of_Stocklevel() {
  Prob_of_StocklevelValues[0] = 4.1;
}



//******************************************************
//print values of gv (for debugging)
//******************************************************
void DIDERO_PC_DefaultRangeStudy::PrintGlobalValues(int expNum) {
  if (NumGVs == 0) {
    cout<<"There are no global variables."<<endl;
    return;
  }

  SetGVs(expNum);

  cout<<"The Global Variable values for experiment "<<
    GetExpName(expNum)<<" are:"<<endl;
  cout << "Choose_Cust_using_ID\tdouble\t" << Choose_Cust_using_ID << endl;
  cout << "GV_Couple_Server_Trans_Durations\tbool\t" << GV_Couple_Server_Trans_Durations << endl;
  cout << "GV_Cust_per_District\tint\t" << GV_Cust_per_District << endl;
  cout << "GV_DefaultResidualTimes\tbool\t" << GV_DefaultResidualTimes << endl;
  cout << "GV_Efficient_Oper_Capacity_Server_1\tint\t" << GV_Efficient_Oper_Capacity_Server_1 << endl;
  cout << "GV_Efficient_Oper_Capacity_Server_2\tint\t" << GV_Efficient_Oper_Capacity_Server_2 << endl;
  cout << "GV_Enable_Client_View_Trace\tshort\t" << GV_Enable_Client_View_Trace << endl;
  cout << "GV_Enable_Server_1_View_Trace\tshort\t" << GV_Enable_Server_1_View_Trace << endl;
  cout << "GV_Enable_Server_2_View_Trace\tshort\t" << GV_Enable_Server_2_View_Trace << endl;
  cout << "GV_ExpScaling_LowerBound\tdouble\t" << GV_ExpScaling_LowerBound << endl;
  cout << "GV_Experiment_Runs\tint\t" << GV_Experiment_Runs << endl;
  cout << "GV_IntraTransDepBurstiness\tbool\t" << GV_IntraTransDepBurstiness << endl;
  cout << "GV_IntraTransaction_Dependence\tbool\t" << GV_IntraTransaction_Dependence << endl;
  cout << "GV_Num_Dist_per_Warehouses\tshort\t" << GV_Num_Dist_per_Warehouses << endl;
  cout << "GV_Number_of_Clients_and_Trans\tshort\t" << GV_Number_of_Clients_and_Trans << endl;
  cout << "GV_Number_of_Warehouses\tshort\t" << GV_Number_of_Warehouses << endl;
  cout << "GV_Oper_Dur_Raw_Data_Scaling\tfloat\t" << GV_Oper_Dur_Raw_Data_Scaling << endl;
  cout << "GV_ReacModel_ExpScaling\tdouble\t" << GV_ReacModel_ExpScaling << endl;
  cout << "GV_ReacModel_PolyPower\tdouble\t" << GV_ReacModel_PolyPower << endl;
  cout << "GV_Server_1_Prob_of_IntraTransDependence\tdouble\t" << GV_Server_1_Prob_of_IntraTransDependence << endl;
  cout << "GV_Server_1_enabled\tbool\t" << GV_Server_1_enabled << endl;
  cout << "GV_Server_2_Prob_of_IntraTransDependence\tdouble\t" << GV_Server_2_Prob_of_IntraTransDependence << endl;
  cout << "GV_Server_2_enabled\tbool\t" << GV_Server_2_enabled << endl;
  cout << "GV_Step_Inverse_Transform\tbool\t" << GV_Step_Inverse_Transform << endl;
  cout << "GV_TPCC\tbool\t" << GV_TPCC << endl;
  cout << "GV_debug_flag\tshort\t" << GV_debug_flag << endl;
  cout << "Prob_of_Bad_Cust\tdouble\t" << Prob_of_Bad_Cust << endl;
  cout << "Prob_of_Cust_ID\tdouble\t" << Prob_of_Cust_ID << endl;
  cout << "Prob_of_Delivery\tdouble\t" << Prob_of_Delivery << endl;
  cout << "Prob_of_Local_Orderlines\tdouble\t" << Prob_of_Local_Orderlines << endl;
  cout << "Prob_of_NewOrder\tdouble\t" << Prob_of_NewOrder << endl;
  cout << "Prob_of_Orderstatus\tdouble\t" << Prob_of_Orderstatus << endl;
  cout << "Prob_of_Payment\tdouble\t" << Prob_of_Payment << endl;
  cout << "Prob_of_Stocklevel\tdouble\t" << Prob_of_Stocklevel << endl;
}


//******************************************************
//retrieve the value of a global variable
//******************************************************
void *DIDERO_PC_DefaultRangeStudy::GetGVValue(char *TheGVName) {
  if (strcmp("Choose_Cust_using_ID", TheGVName) == 0)
    return &Choose_Cust_using_ID;
  else if (strcmp("GV_Couple_Server_Trans_Durations", TheGVName) == 0)
    return &GV_Couple_Server_Trans_Durations;
  else if (strcmp("GV_Cust_per_District", TheGVName) == 0)
    return &GV_Cust_per_District;
  else if (strcmp("GV_DefaultResidualTimes", TheGVName) == 0)
    return &GV_DefaultResidualTimes;
  else if (strcmp("GV_Efficient_Oper_Capacity_Server_1", TheGVName) == 0)
    return &GV_Efficient_Oper_Capacity_Server_1;
  else if (strcmp("GV_Efficient_Oper_Capacity_Server_2", TheGVName) == 0)
    return &GV_Efficient_Oper_Capacity_Server_2;
  else if (strcmp("GV_Enable_Client_View_Trace", TheGVName) == 0)
    return &GV_Enable_Client_View_Trace;
  else if (strcmp("GV_Enable_Server_1_View_Trace", TheGVName) == 0)
    return &GV_Enable_Server_1_View_Trace;
  else if (strcmp("GV_Enable_Server_2_View_Trace", TheGVName) == 0)
    return &GV_Enable_Server_2_View_Trace;
  else if (strcmp("GV_ExpScaling_LowerBound", TheGVName) == 0)
    return &GV_ExpScaling_LowerBound;
  else if (strcmp("GV_Experiment_Runs", TheGVName) == 0)
    return &GV_Experiment_Runs;
  else if (strcmp("GV_IntraTransDepBurstiness", TheGVName) == 0)
    return &GV_IntraTransDepBurstiness;
  else if (strcmp("GV_IntraTransaction_Dependence", TheGVName) == 0)
    return &GV_IntraTransaction_Dependence;
  else if (strcmp("GV_Num_Dist_per_Warehouses", TheGVName) == 0)
    return &GV_Num_Dist_per_Warehouses;
  else if (strcmp("GV_Number_of_Clients_and_Trans", TheGVName) == 0)
    return &GV_Number_of_Clients_and_Trans;
  else if (strcmp("GV_Number_of_Warehouses", TheGVName) == 0)
    return &GV_Number_of_Warehouses;
  else if (strcmp("GV_Oper_Dur_Raw_Data_Scaling", TheGVName) == 0)
    return &GV_Oper_Dur_Raw_Data_Scaling;
  else if (strcmp("GV_ReacModel_ExpScaling", TheGVName) == 0)
    return &GV_ReacModel_ExpScaling;
  else if (strcmp("GV_ReacModel_PolyPower", TheGVName) == 0)
    return &GV_ReacModel_PolyPower;
  else if (strcmp("GV_Server_1_Prob_of_IntraTransDependence", TheGVName) == 0)
    return &GV_Server_1_Prob_of_IntraTransDependence;
  else if (strcmp("GV_Server_1_enabled", TheGVName) == 0)
    return &GV_Server_1_enabled;
  else if (strcmp("GV_Server_2_Prob_of_IntraTransDependence", TheGVName) == 0)
    return &GV_Server_2_Prob_of_IntraTransDependence;
  else if (strcmp("GV_Server_2_enabled", TheGVName) == 0)
    return &GV_Server_2_enabled;
  else if (strcmp("GV_Step_Inverse_Transform", TheGVName) == 0)
    return &GV_Step_Inverse_Transform;
  else if (strcmp("GV_TPCC", TheGVName) == 0)
    return &GV_TPCC;
  else if (strcmp("GV_debug_flag", TheGVName) == 0)
    return &GV_debug_flag;
  else if (strcmp("Prob_of_Bad_Cust", TheGVName) == 0)
    return &Prob_of_Bad_Cust;
  else if (strcmp("Prob_of_Cust_ID", TheGVName) == 0)
    return &Prob_of_Cust_ID;
  else if (strcmp("Prob_of_Delivery", TheGVName) == 0)
    return &Prob_of_Delivery;
  else if (strcmp("Prob_of_Local_Orderlines", TheGVName) == 0)
    return &Prob_of_Local_Orderlines;
  else if (strcmp("Prob_of_NewOrder", TheGVName) == 0)
    return &Prob_of_NewOrder;
  else if (strcmp("Prob_of_Orderstatus", TheGVName) == 0)
    return &Prob_of_Orderstatus;
  else if (strcmp("Prob_of_Payment", TheGVName) == 0)
    return &Prob_of_Payment;
  else if (strcmp("Prob_of_Stocklevel", TheGVName) == 0)
    return &Prob_of_Stocklevel;
  else 
    cerr<<"!! DIDERO_PC_DefaultRangeStudy::GetGVValue: Global Variable "<<TheGVName<<" does not exist."<<endl;
  return NULL;
}


//******************************************************
//override the value of a global variable
//******************************************************
void DIDERO_PC_DefaultRangeStudy::OverrideGVValue(char *TheGVName,void *TheGVValue) {
  if (strcmp("Choose_Cust_using_ID", TheGVName) == 0)
    Choose_Cust_using_ID = *(double *)TheGVValue;
  else if (strcmp("GV_Couple_Server_Trans_Durations", TheGVName) == 0)
    GV_Couple_Server_Trans_Durations = *(bool *)TheGVValue;
  else if (strcmp("GV_Cust_per_District", TheGVName) == 0)
    GV_Cust_per_District = *(int *)TheGVValue;
  else if (strcmp("GV_DefaultResidualTimes", TheGVName) == 0)
    GV_DefaultResidualTimes = *(bool *)TheGVValue;
  else if (strcmp("GV_Efficient_Oper_Capacity_Server_1", TheGVName) == 0)
    GV_Efficient_Oper_Capacity_Server_1 = *(int *)TheGVValue;
  else if (strcmp("GV_Efficient_Oper_Capacity_Server_2", TheGVName) == 0)
    GV_Efficient_Oper_Capacity_Server_2 = *(int *)TheGVValue;
  else if (strcmp("GV_Enable_Client_View_Trace", TheGVName) == 0)
    GV_Enable_Client_View_Trace = *(short *)TheGVValue;
  else if (strcmp("GV_Enable_Server_1_View_Trace", TheGVName) == 0)
    GV_Enable_Server_1_View_Trace = *(short *)TheGVValue;
  else if (strcmp("GV_Enable_Server_2_View_Trace", TheGVName) == 0)
    GV_Enable_Server_2_View_Trace = *(short *)TheGVValue;
  else if (strcmp("GV_ExpScaling_LowerBound", TheGVName) == 0)
    GV_ExpScaling_LowerBound = *(double *)TheGVValue;
  else if (strcmp("GV_Experiment_Runs", TheGVName) == 0)
    GV_Experiment_Runs = *(int *)TheGVValue;
  else if (strcmp("GV_IntraTransDepBurstiness", TheGVName) == 0)
    GV_IntraTransDepBurstiness = *(bool *)TheGVValue;
  else if (strcmp("GV_IntraTransaction_Dependence", TheGVName) == 0)
    GV_IntraTransaction_Dependence = *(bool *)TheGVValue;
  else if (strcmp("GV_Num_Dist_per_Warehouses", TheGVName) == 0)
    GV_Num_Dist_per_Warehouses = *(short *)TheGVValue;
  else if (strcmp("GV_Number_of_Clients_and_Trans", TheGVName) == 0)
    GV_Number_of_Clients_and_Trans = *(short *)TheGVValue;
  else if (strcmp("GV_Number_of_Warehouses", TheGVName) == 0)
    GV_Number_of_Warehouses = *(short *)TheGVValue;
  else if (strcmp("GV_Oper_Dur_Raw_Data_Scaling", TheGVName) == 0)
    GV_Oper_Dur_Raw_Data_Scaling = *(float *)TheGVValue;
  else if (strcmp("GV_ReacModel_ExpScaling", TheGVName) == 0)
    GV_ReacModel_ExpScaling = *(double *)TheGVValue;
  else if (strcmp("GV_ReacModel_PolyPower", TheGVName) == 0)
    GV_ReacModel_PolyPower = *(double *)TheGVValue;
  else if (strcmp("GV_Server_1_Prob_of_IntraTransDependence", TheGVName) == 0)
    GV_Server_1_Prob_of_IntraTransDependence = *(double *)TheGVValue;
  else if (strcmp("GV_Server_1_enabled", TheGVName) == 0)
    GV_Server_1_enabled = *(bool *)TheGVValue;
  else if (strcmp("GV_Server_2_Prob_of_IntraTransDependence", TheGVName) == 0)
    GV_Server_2_Prob_of_IntraTransDependence = *(double *)TheGVValue;
  else if (strcmp("GV_Server_2_enabled", TheGVName) == 0)
    GV_Server_2_enabled = *(bool *)TheGVValue;
  else if (strcmp("GV_Step_Inverse_Transform", TheGVName) == 0)
    GV_Step_Inverse_Transform = *(bool *)TheGVValue;
  else if (strcmp("GV_TPCC", TheGVName) == 0)
    GV_TPCC = *(bool *)TheGVValue;
  else if (strcmp("GV_debug_flag", TheGVName) == 0)
    GV_debug_flag = *(short *)TheGVValue;
  else if (strcmp("Prob_of_Bad_Cust", TheGVName) == 0)
    Prob_of_Bad_Cust = *(double *)TheGVValue;
  else if (strcmp("Prob_of_Cust_ID", TheGVName) == 0)
    Prob_of_Cust_ID = *(double *)TheGVValue;
  else if (strcmp("Prob_of_Delivery", TheGVName) == 0)
    Prob_of_Delivery = *(double *)TheGVValue;
  else if (strcmp("Prob_of_Local_Orderlines", TheGVName) == 0)
    Prob_of_Local_Orderlines = *(double *)TheGVValue;
  else if (strcmp("Prob_of_NewOrder", TheGVName) == 0)
    Prob_of_NewOrder = *(double *)TheGVValue;
  else if (strcmp("Prob_of_Orderstatus", TheGVName) == 0)
    Prob_of_Orderstatus = *(double *)TheGVValue;
  else if (strcmp("Prob_of_Payment", TheGVName) == 0)
    Prob_of_Payment = *(double *)TheGVValue;
  else if (strcmp("Prob_of_Stocklevel", TheGVName) == 0)
    Prob_of_Stocklevel = *(double *)TheGVValue;
  else 
    cerr<<"!! DIDERO_PC_DefaultRangeStudy::OverrideGVValue: Global Variable "<<TheGVName<<" does not exist."<<endl;
}


//******************************************************
//set the value of all global variables to the given exp
//******************************************************
void DIDERO_PC_DefaultRangeStudy::SetGVs(int expNum) {
  Choose_Cust_using_ID = Choose_Cust_using_IDValues[expNum];
  GV_Couple_Server_Trans_Durations = GV_Couple_Server_Trans_DurationsValues[expNum];
  GV_Cust_per_District = GV_Cust_per_DistrictValues[expNum];
  GV_DefaultResidualTimes = GV_DefaultResidualTimesValues[expNum];
  GV_Efficient_Oper_Capacity_Server_1 = GV_Efficient_Oper_Capacity_Server_1Values[expNum];
  GV_Efficient_Oper_Capacity_Server_2 = GV_Efficient_Oper_Capacity_Server_2Values[expNum];
  GV_Enable_Client_View_Trace = GV_Enable_Client_View_TraceValues[expNum];
  GV_Enable_Server_1_View_Trace = GV_Enable_Server_1_View_TraceValues[expNum];
  GV_Enable_Server_2_View_Trace = GV_Enable_Server_2_View_TraceValues[expNum];
  GV_ExpScaling_LowerBound = GV_ExpScaling_LowerBoundValues[expNum];
  GV_Experiment_Runs = GV_Experiment_RunsValues[expNum];
  GV_IntraTransDepBurstiness = GV_IntraTransDepBurstinessValues[expNum];
  GV_IntraTransaction_Dependence = GV_IntraTransaction_DependenceValues[expNum];
  GV_Num_Dist_per_Warehouses = GV_Num_Dist_per_WarehousesValues[expNum];
  GV_Number_of_Clients_and_Trans = GV_Number_of_Clients_and_TransValues[expNum];
  GV_Number_of_Warehouses = GV_Number_of_WarehousesValues[expNum];
  GV_Oper_Dur_Raw_Data_Scaling = GV_Oper_Dur_Raw_Data_ScalingValues[expNum];
  GV_ReacModel_ExpScaling = GV_ReacModel_ExpScalingValues[expNum];
  GV_ReacModel_PolyPower = GV_ReacModel_PolyPowerValues[expNum];
  GV_Server_1_Prob_of_IntraTransDependence = GV_Server_1_Prob_of_IntraTransDependenceValues[expNum];
  GV_Server_1_enabled = GV_Server_1_enabledValues[expNum];
  GV_Server_2_Prob_of_IntraTransDependence = GV_Server_2_Prob_of_IntraTransDependenceValues[expNum];
  GV_Server_2_enabled = GV_Server_2_enabledValues[expNum];
  GV_Step_Inverse_Transform = GV_Step_Inverse_TransformValues[expNum];
  GV_TPCC = GV_TPCCValues[expNum];
  GV_debug_flag = GV_debug_flagValues[expNum];
  Prob_of_Bad_Cust = Prob_of_Bad_CustValues[expNum];
  Prob_of_Cust_ID = Prob_of_Cust_IDValues[expNum];
  Prob_of_Delivery = Prob_of_DeliveryValues[expNum];
  Prob_of_Local_Orderlines = Prob_of_Local_OrderlinesValues[expNum];
  Prob_of_NewOrder = Prob_of_NewOrderValues[expNum];
  Prob_of_Orderstatus = Prob_of_OrderstatusValues[expNum];
  Prob_of_Payment = Prob_of_PaymentValues[expNum];
  Prob_of_Stocklevel = Prob_of_StocklevelValues[expNum];
}


//******************************************************
//static class method called by solvers to create study 
//(and thus create all of the model)
//******************************************************
BaseStudyClass* GlobalStudyPtr = NULL;
BaseStudyClass * GenerateStudy() {
  if (GlobalStudyPtr == NULL)
    GlobalStudyPtr = new DIDERO_PC_DefaultRangeStudy();
  return GlobalStudyPtr;
}

void DestructStudy() {
  delete GlobalStudyPtr;
  GlobalStudyPtr = NULL;
}
//******************************************************
//get and create the PVModel
//******************************************************
PVModel* DIDERO_PC_DefaultRangeStudy::GetPVModel(bool expandTimeArrays) {
  if (ThePVModel!=NULL)
    delete ThePVModel;
  // create the PV model
  ThePVModel=new Durations_of_Requests_and_OperationsPVModel(expandTimeArrays);
  return ThePVModel;
}


