#include "DIDERO_PC.h"
#include <vector>
#include "Client_Interface.h"
#include "Server_Interface.h"
#include "string"

extern short GV_debug_flag;

extern vector<Client_Interface*> ClientObjects;        /* Array of pointers to Client Object interface*/
extern Server_Interface* Server_1;        /* Pointer to Server interface */
extern Server_Interface* Server_2;        /* Pointer to Server interface */
extern map<int, map< int, map< int , string> > > Trans_Oper_Replica_Results;       /* Stores the results of operations executed by the 
Client_ID  Operation_ID   Server_ID                                            replicas. These results are compared by the Middlewware 
                                                                             * for possible inconsistencies. 
                                                                             */

extern map<int, map<int, vector<string> > > Oper_Data_for_Replicas;   /*Array to store the data that defines each operation in a Transaction */
/* Client_ID Operation_ID   Data */


std::string Begin_Transaction(int ID)
{
    /* Randomly choose an instance of a Transaction-type according to the loaded application profile.
     * If the transaction has not been used previously then a new transaction object is created and used.
     * Otherwise, the previous transaction object is reset and used.
     *  
     */
    ClientObjects[ID-1]->Transaction_Instance();
    
    /* Initialize the Middleware relevant buffers used for storing transaction data and results of 
       operations carried out by the replicas 
     */
    (Oper_Data_for_Replicas[ID]).clear();
    (Trans_Oper_Replica_Results[ID]).clear();
    
    /* Call create Transaction */
    if(Server_1)
    {
        Server_1->create_transaction(ID);
        if(GV_debug_flag==5)
        {
            std::cerr << " Begin_Transaction.cpp:: Transaction Object " << ID << " has either been created or is being reused " << std::endl;
        }
    }
    
    /* Call create Transaction */
    if(Server_2)
    {
        Server_2->create_transaction(ID);
        if(GV_debug_flag==5)
        {
            std::cerr << " Begin_Transaction.cpp:: Transaction Object " << ID << " has either been created or is being reused " << std::endl;
        }
    }
    return std::string("Transaction type has been selected");
}
