#include "DIDERO_PC.h"
#include <vector>
#include "Client_Interface.h"
#include "Server_Interface.h"
#include "string"
//#include <sstream>

extern short GV_debug_flag;
extern vector<Client_Interface*> ClientObjects;        /* Array of pointers to Client Object interface*/
extern Server_Interface* Server_1;        /* Array of pointers to Server Object interface*/
extern Server_Interface* Server_2;        /* Array of pointers to Server Object interface*/
extern vector<bool> Exec_Oper_on_both_Servers;         /* Array of booleans to indicate that an operation 
                                                 * has been carried out on both servers. 
                                                 */
extern vector<string> Oper_results;             /* Array of strings to store the result of the faster server */
extern map<int, map< int, map< int , string> > > Trans_Oper_Replica_Results;       /* Stores the results of operations executed by the 
Client_ID  Operation_ID   Server_ID                                            replicas. These results are compared by the Middlewware 
                                                                             * for possible inconsistencies. 
                                                                             */

extern map<int, map<int, vector<string> > > Oper_Data_for_Replicas;   /*Array to store the data that defines each operation in a Transaction */
/* Client_ID Operation_ID   Data */


/* Data structure that keeps count of which operation is currently being executed by a given replica, with respect to a given client */
map<int, map<int, int>  > Server_oper_index;

string DivSQL_Requests(int MW_ID, int Slower_Server)
{
    static string result = string("");
    
    if(Slower_Server==0)
    {
        /* This has been called under "Normal" circumstances with, at least, the faster 
         * server ready to proceed with the next operation
         */
        
        /* Store the data that defines each operation */
        int oper_index = (Oper_Data_for_Replicas[MW_ID]).size() + 1;
        
        if(GV_debug_flag==5)
        {
            std::cerr << "DivSQL_Requests.cpp::  The next operation data being stored in the Oper_Data_for_Replicas data structure, on behalf of Client " << MW_ID << " is " << ClientObjects[MW_ID-1]->get_Shared_Data_Operation() << std::endl;
            std::cerr << "DivSQL_Requests.cpp::  The size of Oper_Data_for_Replicas data structure, on behalf of Client " << MW_ID << " is " << oper_index << std::endl;            
        }
        
        ((Oper_Data_for_Replicas[MW_ID])[oper_index]).push_back(ClientObjects[MW_ID-1]->get_Shared_Data_Operation());
        
        ((Oper_Data_for_Replicas[MW_ID])[oper_index]).push_back(ClientObjects[MW_ID-1]->get_Shared_Data_Key());    
        

        result = ((Oper_Data_for_Replicas[MW_ID])[oper_index])[0];        

    }else
    {
        int oper_index = (Oper_Data_for_Replicas[MW_ID]).size();        
        
        /* The Slower Server is ready to do one of the following things: 
         * 1) It has "caught up" with the faster server and is
         * now ready to perform a "Commit", or;
         * 2) it has thrown an exception and wishes all further 
         * operations from the Client to be abandoned by the Middleware letting
         * the Client know an Abort is imminent!!!!
         *          
         */
        
        if((ClientObjects[MW_ID-1]->get_Oper_Exec_Status()).compare(std::string("Abort"))==0)
        {
            /* STOP THE PRESSES!!! Tell the Middleware to tell the Client that Aborts should
               take place on both Servers */
            
            result = std::string("Abort");
                
        }else if(((((Oper_Data_for_Replicas[MW_ID])[oper_index])[0]).compare(std::string("Commit"))==0)&&(Server_oper_index[MW_ID][1]==Server_oper_index[MW_ID][2]))
        {
            /* Both Servers are ready to commit */
            result = std::string("Commit");
            
        }else
        {
            std::cerr << "DivSQL_Requests.cpp:: The slower server has activated the \"Request_Oper\" Timed-Activity for Client "<< MW_ID <<" under Mysterious circumstances!!!!!" << std::endl;
        }
    }

    
    return result;
};
