/* NOTE: This is an old version of source that will not be included
 * in the build process, but whose code might be useful in the future.*/

#include "DIDERO_PC.h"
#include <map>
//#include <iomanip>
#include <iostream>
#include <vector>
#include <fstream>


using namespace std;

map< int, map<int, map<double, double> > > Emp_Distributions;

int Init_Emp_Dists(string PathToFileWithDataLocations)
{
    int localbool = 0;
    
     /*********************** Read in the Empirical Distributions and initialize Data structures ******************************/ 
     
     Emp_Distributions.clear();
     
     vector<double> unsorted_dist;
     unsorted_dist.clear();
          
     int dist_counter = 0;
     double Prob_percentile = 0;
     double soj_time = 0;
     
    /************ Read in the input files containing distributional information into appropriate data structures **********/
    ifstream fileIn_EmpDist_Paths(PathToFileWithDataLocations.c_str());   //Stream that enables access to the file containing the paths to the Empirical distributions file
    
    
    /* Has the file stream been initialised successfully? */

    if(!fileIn_EmpDist_Paths)
    {
        if(GV_debug_flag==11)
        {
            cerr << "Empirical_Distributions_Main.cpp:   Can't open input file " << PathToFileWithDataLocations.c_str() << ".\n" << endl;
        }
        
        localbool = 0;
        return localbool;
    }
    else
    {
	if(GV_debug_flag==5)
        {
            cerr << "Empirical_Distributions_Main.cpp: Input file " << PathToFileWithDataLocations.c_str() << " was opened.\n" << endl;
        }
    }    

    if(fileIn_EmpDist_Paths.eof())
    {
        if(GV_debug_flag==5)
        {
            cerr << "Empirical_Distributions_Main.cpp: " << PathToFileWithDataLocations.c_str() <<" is not formatted correctly. It has no data within it."<< endl;
        }
        
        localbool = 0;                  /* Set a boolean that will indicate to the client that the simulation should terminate.*/
        return localbool;
    }else
    {
        /* Iterate through the file, each time obtaining the path to the Empirical distribution file.
         * Populate a data structure to hold each Empirical distribution. */
        
        string line("");

        ifstream fileIn_EmpDist;   //Stream that enables access to the file containing the paths to the Empirical distributions file                            
        
        /*Read first line in the file. I assume this should be a line with the string "Section" in it*/
        line.clear();
        getline(fileIn_EmpDist_Paths,line);
        
        while(!fileIn_EmpDist_Paths.eof())
        {
            fileIn_EmpDist.open(line.c_str());        
            
            /* Initialize variables */
            dist_counter = dist_counter + 1;
            Prob_percentile = 0;
            soj_time = 0;

            (Emp_Distributions[dist_counter]).clear();
                        
            if(!fileIn_EmpDist)
            {
                if(GV_debug_flag==5)
                {
                    cerr << "Empirical_Distributions_Main.cpp:   Can't open input file " << line.c_str() << ".\n" << endl;
                }
                
                localbool = 0;
                return localbool;
            }else
            {
                if(GV_debug_flag==5)
                {
                    cerr << "Empirical_Distributions_Main.cpp: Input file " << line.c_str() << " was opened.\n" << endl;
                }
            }                
            
            unsorted_dist.clear();
            
            string local_line("");
            local_line.clear();

            while(getline(fileIn_EmpDist,local_line))
            {
                if(!local_line.empty())
                {
                    soj_time = atof(local_line.c_str());
                    unsorted_dist.push_back(soj_time);                    
                }
            }
            
            /* Sort the values */
            sort(unsorted_dist.begin(), unsorted_dist.end());
            
            /* Create the distribution */
            Prob_percentile = 0;
            for(vector<double>::iterator iter = unsorted_dist.begin(); iter!=unsorted_dist.end(); iter++)
            {
                Prob_percentile = Prob_percentile + 1;
                (Emp_Distributions[dist_counter])[Prob_percentile/unsorted_dist.size()]=(*iter);
            }
            
            if(GV_debug_flag==5)
            {
                cerr << "Empirical_Distributions_Main.cpp: The "<< dist_counter << "th distribution has been created!!!"<< endl;
            }
            
            /* Reset filestream for next file */
            fileIn_EmpDist.clear();
            fileIn_EmpDist.close();

            line.clear();
            getline(fileIn_EmpDist_Paths,line);            
        }
        
        fileIn_EmpDist_Paths.clear();
        fileIn_EmpDist_Paths.close();
    }
    return localbool;
}

