/* 
 * File:   Server_Interface.h
 * Author: kizito
 *
 * Created on 23 October 2013, 13:25
 */

#ifndef SERVER_INTERFACE_2_H
#define	SERVER_INTERFACE_2_H

#ifdef MY_COMPILE_DLL
#define MY_DECLSPEC __declspec(dllexport)
#else
#define MY_DECLSPEC __declspec(dllimport)
#endif

#include <iostream>
#include <map>
#include <string>
#include <deque>

class MY_DECLSPEC Server_Interface_2
{
        public:
        
        virtual ~Server_Interface_2(){};
        /* These Methods will add to the arrays that store information about which transactions are 
         * active or not, whether the history of a transaction is still relevant or not for other 
         * transactions, and what the history of the transactions are.
         */

        typedef unsigned int my_int_;
        
        //virtual int new_Transaction_Status(my_int_ Trans_ID, my_int_ status_alive) = 0;
        //virtual int delete_Transaction_Status(my_int_ Trans_ID) = 0;
        //virtual int new_Transaction_ParentStatus(my_int_ Trans_ID, my_int_ status_parent) = 0;
        //virtual int delete_Transaction_ParentStatus(my_int_  Trans_ID) = 0;
        //virtual int new_Transaction_History(my_int_ Trans_ID, std::string operation) = 0;
        //virtual int delete_Transaction_History(my_int_ Trans_ID) = 0;

        //virtual int get_Transaction_Status(my_int_ Trans_ID) = 0;
        //virtual int get_Transaction_ParentStatus(my_int_ Trans_ID) = 0;
        
        //virtual int increase_Transaction_Status(my_int_ Trans_ID) = 0;
        //virtual int decrease_Transaction_Status(my_int_ Trans_ID) = 0;
                
        //virtual int increase_Transaction_ParentStatus(my_int_ Trans_ID) = 0;
        //virtual int decrease_Transaction_ParentStatus(my_int_ Trans_ID) = 0;
        
        virtual int create_transaction(my_int_ Client_ID) = 0; //Done
        //virtual int delete_transaction(my_int_ Trans_ID) = 0;
        
        
        /* "Operation" and related sub-methods */
        virtual std::string Operation(my_int_ Client_ID, std::string Oper_type, std::string Database_Location) = 0;
        
        virtual std::string Read(my_int_ Client_ID, std::string Database_Location) = 0;
        virtual std::string Write(my_int_ Client_ID, std::string Database_Location) = 0;
        virtual std::string Abort(my_int_ Client_ID) = 0;
        virtual std::string Commit(my_int_ Client_ID) = 0;
        
        /* Get methods */
        virtual bool get_Abort(my_int_ Client_ID) = 0;
        virtual bool get_Blocked(my_int_ Client_ID) = 0;
        
        private:
            
        /* WARNING: Must remember that the same transaction object can be used to simulate
         * "different" transactions serially. Consequently, Transaction IDs must change while
         * Client IDs remain the same. The Transaction IDs stored in the server data structures
         * must be the uniquely generated Transaction IDs for each new transaction, and not the 
         * "static" Client IDs of Clients "tethered" to these transactions 
         */            
            
        /* Transactions */
        
        /* */
        typedef std::map<my_int_ , std::map<my_int_ , my_int_> > Parent_Trans_;
        Parent_Trans_ Parent_Trans;
        
            
};




typedef Server_Interface_2* (*create_Server_2)(char*);               /*There should be a method, implemented in the same source file as the plugin
                                                                 class definition (the most specialised/"derived" class in the
                                                                 *plugin hierarchy), whose prototype matches
                                                                 this typedef and the purpose of which is to instantiate an
                                                                 object of the class--type that is "highest"/leaf/"most specialised"
                                                                 in the hierarchy*/
typedef void (*destroy_Server_2)(Server_Interface_2*);

#endif	/* SERVER_INTERFACE_2_H */
