#include "DIDERO_PC.h"
#include <vector>
#include "Client_Interface.h"
#include "Server_Interface.h"
#include "string"
//#include <sstream>

extern short GV_debug_flag;
extern vector<Client_Interface*> ClientObjects;        /* Array of pointers to Client Object interface*/
extern Server_Interface* Server_1;        /* Array of pointers to Client Object interface*/
extern Server_Interface* Server_2;        /* Array of pointers to Client Object interface*/
extern vector<bool> Exec_Oper_on_both_Servers;         /* Array of booleans to indicate that an operation 
                                                 * has been carried out on both servers. 
                                                 */
extern vector<string> Oper_results;             /* Array of strings to store the result of the faster server */
extern map<int, map< int, map< int , string> > > Trans_Oper_Replica_Results;       /* Stores the results of operations executed by the 
Client_ID  Operation_ID   Server_ID                                            replicas. These results are compared by the Middlewware 
                                                                             * for possible inconsistencies. 
                                                                             */

extern map<int, map<int, vector<string> > > Oper_Data_for_Replicas;   /*Array to store the data that defines each operation in a Transaction */
/* Client_ID Operation_ID   Data */

/* Data structure that keeps count of which operation is currently being executed by a given replica, with respect to a given client */
extern map<int, map<int, int>  > Server_oper_index;

map<int,bool> faster_server_decided;

string DivSQL_Results(int concurrent_results, int MW_ID, int Server_ID)
{
    int faster_server = 0;
    int slower_server = 0;
    int equal_server = 0;
    
    string result("");
    
    /* Determine if it is the faster or slower server returning the result */
    if(Server_ID==1)
    {
        /* If the results from the servers have arrived "at the same time" with "the same number of operations performed", 
         * then the question of which is first is ill-defined and should be determined 
         */
        if(GV_debug_flag==5)
        {
            std::cerr << "DivSQL_Results.cpp:: The values of the Transaction progress index on each Server for Client " << MW_ID << " are Server 1 : " << (Server_oper_index[MW_ID])[1] << ", and Server 2 : " << (Server_oper_index[MW_ID])[2] <<std::endl;
        }            
        
        if(concurrent_results!=1)
        {
            if((Server_oper_index[MW_ID])[1] > (Server_oper_index[MW_ID])[2])
            {
                faster_server = Server_ID;

                if(GV_debug_flag==5)
                {
                    std::cerr << "DivSQL_Results.cpp:: The faster (1) Server for Client " << MW_ID << " is Server " << Server_ID << ", and it is returning its result " <<std::endl;
                }            

            }else if((Server_oper_index[MW_ID])[1] < (Server_oper_index[MW_ID])[2])
            {
                slower_server = Server_ID;
                if(GV_debug_flag==5)
                {
                    std::cerr << "DivSQL_Results.cpp:: The slower (1) Server for Client " << MW_ID << " is Server " << Server_ID << ", and it is returning its result " <<std::endl;
                }                        

            }
            else if((Server_oper_index[MW_ID])[1] == (Server_oper_index[MW_ID])[2])
            {
                if((Oper_Data_for_Replicas[MW_ID]).size()==(Server_oper_index[MW_ID])[Server_ID])
                {
                    /* Check if the faster server is just returning its results */
                    if(faster_server_decided[MW_ID]==false)
                    {
                        /* Indicate that the faster server has returned its results */
                        faster_server_decided[MW_ID] = true;
                        faster_server = Server_ID;
                        if(GV_debug_flag==5)
                        {
                            std::cerr << "DivSQL_Results.cpp:: (1) The faster, but equal Server for Client " << MW_ID << " is Server " << Server_ID << ", and it is returning its result " <<std::endl;
                        }                                            
                    }else
                    {
                        /* Indicate that the slower server has caught up with the faster server */
                        faster_server_decided[MW_ID] = false;
                        equal_server = Server_ID;
                        if(GV_debug_flag==5)
                        {
                            std::cerr << "DivSQL_Results.cpp:: (1) The slower, but equal Server for Client " << MW_ID << " is Server " << Server_ID << ", and it is returning its result " <<std::endl;
                        }                                                                
                    }                    
                }else
                {
                    /* The Client has already sent the next operation to the faster server */
                    
                }
                

            }            
        }else
        {
            if((Server_oper_index[MW_ID])[1] > (Server_oper_index[MW_ID])[2])
            {
                faster_server = Server_ID;

                if(GV_debug_flag==5)
                {
                    std::cerr << "DivSQL_Results.cpp:: The faster Server (2) for Client " << MW_ID << " is Server " << Server_ID << ", and it is returning its result " <<std::endl;
                }            

            }else if((Server_oper_index[MW_ID])[1] < (Server_oper_index[MW_ID])[2])
            {
                slower_server = Server_ID;
                if(GV_debug_flag==5)
                {
                    std::cerr << "DivSQL_Results.cpp:: The slower Server (2) for Client " << MW_ID << " is Server " << Server_ID << ", and it is returning its result " <<std::endl;
                }                        

            }
            else if((Server_oper_index[MW_ID])[1] == (Server_oper_index[MW_ID])[2])
            {
                /* Check if the faster server is just returning its results */
                if(faster_server_decided[MW_ID]==false)
                {
                    /* Indicate that the faster server has returned its results */
                    faster_server_decided[MW_ID] = true;
                    faster_server = Server_ID;
                    if(GV_debug_flag==5)
                    {
                        std::cerr << "DivSQL_Results.cpp:: (2) The faster, but equal Server for Client " << MW_ID << " is Server " << Server_ID << ", and it is returning its result " <<std::endl;
                    }                                            
                }else
                {
                    /* Indicate that the slower server has caught up with the faster server */
                    faster_server_decided[MW_ID] = false;
                    equal_server = Server_ID;
                    if(GV_debug_flag==5)
                    {
                        std::cerr << "DivSQL_Results.cpp:: (3) The slower, but equal Server for Client " << MW_ID << " is Server " << Server_ID << ", and it is returning its result " <<std::endl;
                    }                                                                
                }
            }                        
        }

    }else if(Server_ID==2)
    {
        /* If the results from the servers have arrived "at the same time" with "the same number of operations performed", 
         * then the question of which is first is ill-defined and should be determined 
         */
        if(GV_debug_flag==5)
        {
            std::cerr << "DivSQL_Results.cpp:: The values of the Transaction progress index on each Server for Client " << MW_ID << " are Server 1 : " << (Server_oper_index[MW_ID])[1] << ", and Server 2 : " << (Server_oper_index[MW_ID])[2] <<std::endl;
        }            
       
        /* If the results from the servers have arrived "at the same time" with "the same number of operations performed", 
         * then the question of which is first is ill-defined and should be determined 
         */
        if(concurrent_results!=1)
        {
            if((Server_oper_index[MW_ID])[2] > (Server_oper_index[MW_ID])[1])
            {
                faster_server = Server_ID;
                if(GV_debug_flag==5)
                {
                    std::cerr << "DivSQL_Results.cpp:: The faster Server (3) for Client " << MW_ID << " is Server " << Server_ID << ", and it is returning its result " <<std::endl;
                }                        

            }else if((Server_oper_index[MW_ID])[2] < (Server_oper_index[MW_ID])[1])
            {
                slower_server = Server_ID;
                if(GV_debug_flag==5)
                {
                    std::cerr << "DivSQL_Results.cpp:: The slower Server (3) for Client " << MW_ID << " is Server " << Server_ID << ", and it is returning its result " <<std::endl;
                }                        
            }else if((Server_oper_index[MW_ID])[2] == (Server_oper_index[MW_ID])[1])
            {
                /* Check if the faster server is just returning its results */
                if(faster_server_decided[MW_ID]==false)
                {
                    /* Indicate that the faster server has returned its results */
                    faster_server_decided[MW_ID] = true;
                    faster_server = Server_ID;
                    if(GV_debug_flag==5)
                    {
                        std::cerr << "DivSQL_Results.cpp:: (3) The faster, but equal Server for Client " << MW_ID << " is Server " << Server_ID << ", and it is returning its result " <<std::endl;
                    }                                            
                }else
                {
                    /* Indicate that the slower server has caught up with the faster server */
                    faster_server_decided[MW_ID] = false;
                    equal_server = Server_ID;
                    if(GV_debug_flag==5)
                    {
                        std::cerr << "DivSQL_Results.cpp:: (3) The slower, but equal Server for Client " << MW_ID << " is Server " << Server_ID << ", and it is returning its result " <<std::endl;
                    }                                                                
                }
            }            
        }else
        {
            if((Server_oper_index[MW_ID])[2] > (Server_oper_index[MW_ID])[1])
            {
                faster_server = Server_ID;
                if(GV_debug_flag==5)
                {
                    std::cerr << "DivSQL_Results.cpp:: The faster Server (4) for Client " << MW_ID << " is Server " << Server_ID << ", and it is returning its result " <<std::endl;
                }                        

            }else if((Server_oper_index[MW_ID])[2] < (Server_oper_index[MW_ID])[1])
            {
                slower_server = Server_ID;
                if(GV_debug_flag==5)
                {
                    std::cerr << "DivSQL_Results.cpp:: The slower Server (4) for Client " << MW_ID << " is Server " << Server_ID << ", and it is returning its result " <<std::endl;
                }                        
            }else if((Server_oper_index[MW_ID])[2] == (Server_oper_index[MW_ID])[1])
            {
                /* Check if the faster server is just returning its results */
                if(faster_server_decided[MW_ID]==false)
                {
                    /* Indicate that the faster server has returned its results */
                    faster_server_decided[MW_ID] = true;
                    faster_server = Server_ID;
                    if(GV_debug_flag==5)
                    {
                        std::cerr << "DivSQL_Results.cpp:: (4) The faster, but equal Server for Client " << MW_ID << " is Server " << Server_ID << ", and it is returning its result " <<std::endl;
                    }                                            
                }else
                {
                    /* Indicate that the slower server has caught up with the faster server */
                    faster_server_decided[MW_ID] = false;
                    equal_server = Server_ID;
                    if(GV_debug_flag==5)
                    {
                        std::cerr << "DivSQL_Results.cpp:: (4) The slower, but equal Server for Client " << MW_ID << " is Server " << Server_ID << ", and it is returning its result " <<std::endl;
                    }                                                                
                }
            }                        
        }
    }
    
    if(faster_server>0)
    {
        /* Is this reporting a Commit or Abort Success? */
        if(((((Trans_Oper_Replica_Results[MW_ID])[(Server_oper_index[MW_ID])[Server_ID]])[Server_ID]).compare(std::string("Commit success"))==0)||((((Trans_Oper_Replica_Results[MW_ID])[(Server_oper_index[MW_ID])[Server_ID]])[Server_ID]).compare(std::string("Abort success"))==0))
        {
            /* Yes. Okay, wait for slower server */
            result.clear();
            result = std::string("Wait for slower Server");
            
        }else
        {
            /* No. Okay, is this an exception? */
            if((((Trans_Oper_Replica_Results[MW_ID])[(Server_oper_index[MW_ID])[Server_ID]])[Server_ID]).compare(std::string("Abort"))==0)
            {
                /* Yes. Okay, was the last result returned by the slower server a benign one? */
                if((((Trans_Oper_Replica_Results[MW_ID])[(Server_oper_index[MW_ID])[((Server_ID==1)? 2 : 1)]])[((Server_ID==1)? 2 : 1)]).compare(std::string("Abort"))!=0)
                {
                    /* Yes. Okay, wait for slower server */
                    result.clear();
                    result = std::string("Wait for slower Server");                   
                    if(GV_debug_flag==9)
                    {
                        std::cerr << "DivSQL_Results.cpp:: The faster Server for Client " << MW_ID << " is Server " << Server_ID << ", and it is returning an Abort, then waiting for the slower server " <<std::endl;
                    }                                            
                    
                }else
                {
                    /* No. Okay tell the Middleware to instigate the aborting of both transactions */
                    result.clear();
                    result = std::string("Exception");
                    ClientObjects[MW_ID-1]->set_Oper_Exec_Status(std::string("Abort"));

                    if(GV_debug_flag==9)
                    {
                        std::cerr << "DivSQL_Results.cpp:: The faster Server for Client " << MW_ID << " is Server " << Server_ID << ", and it is returning an Abort confirmation " <<std::endl;
                    }                                            
                
                }
            }else
            {
                /* No. Okay, save results and return results to client */
                result.clear();
                result = (((Trans_Oper_Replica_Results[MW_ID])[(Server_oper_index[MW_ID])[Server_ID]])[Server_ID]);
                ClientObjects[MW_ID-1]->set_Oper_Exec_Status((((Trans_Oper_Replica_Results[MW_ID])[(Server_oper_index[MW_ID])[Server_ID]])[Server_ID]));
            }
        }
    }else if(slower_server > 0)
    {
        /* Is the result an exception? */
        if((((Trans_Oper_Replica_Results[MW_ID])[(Server_oper_index[MW_ID])[Server_ID]])[Server_ID]).compare(std::string("Abort"))==0)
        {
            /* Yes. Okay, did the faster server give an exception previously? */
            if((((Trans_Oper_Replica_Results[MW_ID])[(Server_oper_index[MW_ID])[((Server_ID==1)? 2 : 1)]])[((Server_ID==1)? 2 : 1)]).compare(std::string("Abort"))==0)
            {
                /* Yes. Okay, the Middleware should send the exception back to the client, resulting in both servers aborting the corresponding transactions */
                result.clear();
                result = std::string("Exception");
                ClientObjects[MW_ID-1]->set_Oper_Exec_Status(std::string("Abort"));
                
                if(GV_debug_flag==9)
                {
                    std::cerr << "DivSQL_Results.cpp:: The slower Server for Client " << MW_ID << " is Server " << Server_ID << ", and it is returning an Abort confirmation " <<std::endl;
                }                            
                
            }else
            {
                /* If the faster server is ready to commit then this should be interrupted. The faster server will 
                   be waiting for the slower server before it commits, so all we have to ensure is that this slower 
                 * server does not keep the faster server waiting
                 */
                
                if(((((Oper_Data_for_Replicas[MW_ID])[(Oper_Data_for_Replicas[MW_ID]).size()])[0]).compare(string("Commit"))==0)&&(((Trans_Oper_Replica_Results[MW_ID])[(Trans_Oper_Replica_Results[MW_ID]).size()]).size()==2))
                {
                    /* Activate the "Client Request" Timed Activity */
                    /* No. Okay, Activate the slower server to perform its next operation */
                    result.clear();
                    result = std::string("Activate for Abort");
                    ClientObjects[MW_ID-1]->set_Oper_Exec_Status(std::string("Abort"));
                    
                }else
                {
                    /* No. okay, Wait for faster server */
                    result.clear();
                    result = std::string("Wait for faster Server");
                    ClientObjects[MW_ID-1]->set_Oper_Exec_Status(std::string("Abort"));
                }
            }
            
        }else
        {
            /* No. Okay, did the faster server give an exception previously? */
            if((((Trans_Oper_Replica_Results[MW_ID])[(Server_oper_index[MW_ID])[((Server_ID==1)? 2 : 1)]])[((Server_ID==1)? 2 : 1)]).compare(std::string("Abort"))==0)
            {
                /* Yes. Okay, the Middleware should send the exception back to the client, resulting in both servers aborting the corresponding transactions */
                result.clear();
                result = std::string("Exception");
                ClientObjects[MW_ID-1]->set_Oper_Exec_Status(std::string("Abort"));
            }else
            {
                /* No. Okay, Activate the slower server to perform its next operation */
                result.clear();
                result = std::string("Activate slower Server");
            }
        }
    
    }else if(equal_server>0)
    {
        /* Is this a Commit or Abort Success? */
        if(((((Trans_Oper_Replica_Results[MW_ID])[(Server_oper_index[MW_ID])[Server_ID]])[Server_ID]).compare(std::string("Commit success"))==0)||((((Trans_Oper_Replica_Results[MW_ID])[(Server_oper_index[MW_ID])[Server_ID]])[Server_ID]).compare(std::string("Abort success"))==0))
        {
            /* Aborts and Commits Never fail!!!! */    
            result.clear();
            result = std::string("Commit or Abort success");
            ClientObjects[MW_ID-1]->set_Oper_Exec_Status((((Trans_Oper_Replica_Results[MW_ID])[(Server_oper_index[MW_ID])[Server_ID]])[Server_ID]));                

        }else if((((Trans_Oper_Replica_Results[MW_ID])[(Server_oper_index[MW_ID])[Server_ID]])[Server_ID]).compare(std::string("Abort"))==0)
        {
            /* Is the result an exception? */
            
            /* Yes. Okay, did the faster server give an exception previously? */
            if((((Trans_Oper_Replica_Results[MW_ID])[(Server_oper_index[MW_ID])[((Server_ID==1)? 2 : 1)]])[((Server_ID==1)? 2 : 1)]).compare(std::string("Abort"))==0)
            {
                /* Yes. Okay, the Middleware should send the exception back to the client, resulting in both servers aborting the corresponding transactions */
                result.clear();
                result = std::string("Exception");
                ClientObjects[MW_ID-1]->set_Oper_Exec_Status(std::string("Abort"));
                
                if(GV_debug_flag==9)
                {
                    std::cerr << "DivSQL_Results.cpp:: The slower Server for Client " << MW_ID << " is Server " << Server_ID << ", and it is returning an Abort confirmation " <<std::endl;
                }                                            
            }else
            {
                /* If the faster server is ready to commit then this should be interrupted. The faster server will 
                   be waiting for the slower server before it commits, so all we have to ensure is that this slower 
                 * server does not keep the faster server waiting
                 */
                
                if(((((Oper_Data_for_Replicas[MW_ID])[(Oper_Data_for_Replicas[MW_ID]).size()])[0]).compare(string("Commit"))==0)&&(((Trans_Oper_Replica_Results[MW_ID])[(Trans_Oper_Replica_Results[MW_ID]).size()]).size()==2))
                {
                    /* Activate the "Client Request" Timed Activity */
                    /* No. Okay, Activate the slower server to perform its next operation */
                    result.clear();
                    result = std::string("Activate for Abort");
                    ClientObjects[MW_ID-1]->set_Oper_Exec_Status(std::string("Abort"));
                    
                }else
                {
                    /* No. okay, Wait for faster server */
                    result.clear();
                    result = std::string("Wait for faster Server");
                    ClientObjects[MW_ID-1]->set_Oper_Exec_Status(std::string("Abort"));
                }
            }
            
        }else
        {
            /* No. Okay, did the faster server give an exception previously? */
            if((((Trans_Oper_Replica_Results[MW_ID])[(Server_oper_index[MW_ID])[((Server_ID==1)? 2 : 1)]])[((Server_ID==1)? 2 : 1)]).compare(std::string("Abort"))==0)
            {
                /* Yes. Okay, the Middleware should send the exception back to the client, resulting in both servers aborting the corresponding transactions */
                result.clear();
                result = std::string("Exception");
                ClientObjects[MW_ID-1]->set_Oper_Exec_Status(std::string("Abort"));
            }else
            {
                /* Do not return results to Client. Acknowledge receipt of result to relevant server and wait for next operation from Client */
                result.clear();
                result = std::string("Activate slower Server");
            }
        }        
                
    }else
    {
        if(GV_debug_flag==5)
        {
            std::cerr << "DivSQL_Results.cpp:: this error has been generated because the places that enable this method call are automatically set to zero by Mobius!!!!!!" << std::endl;
        }
    }
    
    if(result.compare(std::string(""))==0)
    {
        if(GV_debug_flag==5)
        {
            std::cerr << "DivSQL_Results.cpp:: An error has occurred since NO RESULT is being returned by server "<< Server_ID <<" the Middleware!!!!" << std::endl;
        }        
    }

        if(GV_debug_flag==5)
        {
            std::cerr << "DivSQL_Results.cpp:: The result processed by the Middleware for Client " << MW_ID << " and Server " << Server_ID << "  is " << result <<" !!!!!!!!"<<std::endl;
        }                
    
    return result;
};
